/* A Bison parser, made from parser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	TK_DOC	257
# define	TK_EXPORTEDDOC	258
# define	TK_MAKEFILE	259
# define	TK_ACCESSCODE	260
# define	TK_VARCODE	261
# define	TK_POSTINITCODE	262
# define	TK_CPPCODE	263
# define	TK_MODCODE	264
# define	TK_TYPECODE	265
# define	TK_PREPYCODE	266
# define	TK_PYCODE	267
# define	TK_COPYING	268
# define	TK_MAPPEDTYPE	269
# define	TK_CODEBLOCK	270
# define	TK_IF	271
# define	TK_END	272
# define	TK_NAME	273
# define	TK_PATHNAME	274
# define	TK_STRING	275
# define	TK_VIRTUALCATCHERCODE	276
# define	TK_VIRTUALCODE	277
# define	TK_METHODCODE	278
# define	TK_MEMBERCODE	279
# define	TK_FROMTYPE	280
# define	TK_TOTYPE	281
# define	TK_TOSUBCLASS	282
# define	TK_INCLUDE	283
# define	TK_OPTINCLUDE	284
# define	TK_IMPORT	285
# define	TK_HEADERCODE	286
# define	TK_MODHEADERCODE	287
# define	TK_TYPEHEADERCODE	288
# define	TK_EXPHEADERCODE	289
# define	TK_MODULE	290
# define	TK_CLASS	291
# define	TK_STRUCT	292
# define	TK_PUBLIC	293
# define	TK_PROTECTED	294
# define	TK_PRIVATE	295
# define	TK_SIGNALS	296
# define	TK_SLOTS	297
# define	TK_BOOL	298
# define	TK_SHORT	299
# define	TK_INT	300
# define	TK_LONG	301
# define	TK_FLOAT	302
# define	TK_DOUBLE	303
# define	TK_CHAR	304
# define	TK_VOID	305
# define	TK_PYOBJECT	306
# define	TK_PYTUPLE	307
# define	TK_PYLIST	308
# define	TK_PYDICT	309
# define	TK_PYCALLABLE	310
# define	TK_PYSLICE	311
# define	TK_VIRTUAL	312
# define	TK_ENUM	313
# define	TK_UNSIGNED	314
# define	TK_SCOPE	315
# define	TK_LOGICAL_OR	316
# define	TK_CONST	317
# define	TK_STATIC	318
# define	TK_SIPSIGNAL	319
# define	TK_SIPSLOT	320
# define	TK_SIPRXCON	321
# define	TK_SIPRXDIS	322
# define	TK_SIPSLOTCON	323
# define	TK_SIPSLOTDIS	324
# define	TK_NUMBER	325
# define	TK_REAL	326
# define	TK_TYPEDEF	327
# define	TK_NAMESPACE	328
# define	TK_TIMELINE	329
# define	TK_PLATFORMS	330
# define	TK_FEATURE	331
# define	TK_LICENSE	332
# define	TK_EXPOSE	333
# define	TK_QCHAR	334
# define	TK_TRUE	335
# define	TK_FALSE	336
# define	TK_OPERATOR	337
# define	TK_THROW	338
# define	TK_QOBJECT	339

#line 16 "parser.y"

#include <stdlib.h>
#include <string.h>

#include "sip.h"


#define	MAX_NESTED_IF		10
#define	MAX_NESTED_SCOPE	10

#define	isMainModule(m)		(currentSpec -> module == (m))


/* The different attribute name types. */

typedef enum {
	func_attr,
	var_attr,
	enum_attr,
	class_attr
} attrType;


static sipSpec *currentSpec;		/* The current spec being parsed. */
static stringList *neededQualifiers;	/* The list of required qualifiers. */
static stringList *excludedQualifiers;	/* The list of excluded qualifiers. */
static moduleDef *currentModule;	/* The current module being parsed. */
static mappedTypeDef *currentMappedType;	/* The current mapped type. */
static enumDef *currentEnum;		/* The current enum being parsed. */
static int sectionFlags;		/* The current section flags. */
static int currentOverIsVirt;		/* Set if the overload is virtual. */
static int currentIsStatic;		/* Set if the current is static. */
static char *previousFile;		/* The file just parsed. */
static parserContext newContext;	/* The new pending context. */
static int skipStackPtr;		/* The skip stack pointer. */
static int skipStack[MAX_NESTED_IF];	/* Stack of skip flags. */
static classDef *scopeStack[MAX_NESTED_SCOPE];	/* The scope stack. */
static int sectFlagsStack[MAX_NESTED_SCOPE];	/* The section flags stack. */
static int currentScopeIdx;		/* The scope stack index. */


static nameDef *cacheName(sipSpec *,moduleDef *,char *);
static ifaceFileDef *findIfaceFile(sipSpec *,scopedNameDef *,ifaceFileType,
				   argDef *);
static classDef *findClass(sipSpec *,ifaceFileType,scopedNameDef *);
static classDef *newClass(sipSpec *,ifaceFileType,scopedNameDef *);
static void finishClass(classDef *,optFlags *);
static mappedTypeDef *newMappedType(sipSpec *,argDef *);
static enumDef *newEnum(sipSpec *,moduleDef *,char *,int);
static void newTypedef(sipSpec *,char *,argDef *);
static void newVar(sipSpec *,moduleDef *,char *,int,argDef *,codeBlock *);
static void newCtor(char *,int,funcArgs *,optFlags *,codeBlock *,codeBlock *,
		    throwArgs *,signatureDef *);
static void newFunction(sipSpec *,moduleDef *,int,int,int,argDef *,char *,
			funcArgs *,int,int,optFlags *,codeBlock *,codeBlock *,
			codeBlock *,codeBlock *,throwArgs *,signatureDef *);
static optFlag *findOptFlag(optFlags *,char *,flagType);
static memberDef *findFunction(sipSpec *,moduleDef *,classDef *,char *,
			       slotType);
static void checkAttributes(sipSpec *,classDef *,nameDef *,attrType);
static void newModule(FILE *,char *);
static void appendCodeBlock(codeBlock **,codeBlock *);
static void parseFile(FILE *,char *,moduleDef *,int);
static void handleEOF(void);
static void handleEOM(void);
static qualDef *findQualifier(sipSpec *,char *);
static scopedNameDef *text2scopedName(char *);
static void pushScope(classDef *);
static void popScope(void);
static classDef *currentScope(void);
static void newQualifier(sipSpec *,moduleDef *,int,char *,qualType);
static void newImport(sipSpec *,char *);
static void usedInMainModule(sipSpec *,ifaceFileDef *);
static int timePeriod(sipSpec *,char *,char *);
static int platOrFeature(sipSpec *,char *,int);
static int isExcluded(qualDef *qd);
static int isNeeded(qualDef *);
static int notSkipping(void);
static void appendToClassList(classList **,classDef *);
static void getHooks(optFlags *,char **,char **);

#line 98 "parser.y"
#ifndef YYSTYPE
typedef union {
	char		qchar;
	char		*text;
	long		number;
	double		real;
	argDef		memArg;
	funcArgs	arglist;
	signatureDef	*optsignature;
	throwArgs	*throwlist;
	codeBlock	*codeb;
	valueDef	value;
	valueDef	*valp;
	optFlags	optflags;
	optFlag		flag;
	scopedNameDef	*scpvalp;
	fcallDef	fcall;
	int		boolean;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		453
#define	YYFLAG		-32768
#define	YYNTBASE	108

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 339 ? yytranslate[x] : 217)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    91,     2,     2,     2,   103,   104,     2,
      89,    90,   101,    95,    93,    92,     2,   102,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    98,    88,
     106,    94,   107,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    99,     2,   100,   105,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    86,    96,    87,    97,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     5,     6,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    53,    55,    57,
      59,    61,    63,    65,    67,    69,    71,    72,    80,    82,
      85,    87,    90,    93,    94,   102,   104,   107,   108,   114,
     116,   119,   121,   124,   125,   131,   133,   136,   138,   143,
     145,   148,   152,   157,   159,   163,   165,   168,   171,   175,
     176,   178,   181,   184,   187,   188,   191,   194,   197,   200,
     203,   206,   209,   212,   215,   218,   221,   224,   227,   230,
     233,   236,   239,   244,   247,   248,   256,   257,   259,   260,
     262,   263,   265,   267,   270,   272,   274,   278,   279,   281,
     282,   285,   287,   291,   293,   295,   297,   298,   300,   302,
     304,   306,   309,   311,   315,   317,   319,   324,   326,   328,
     330,   332,   334,   336,   337,   339,   343,   348,   352,   353,
     362,   363,   373,   374,   377,   379,   383,   385,   387,   390,
     392,   394,   396,   398,   400,   402,   404,   406,   408,   410,
     412,   414,   416,   419,   422,   426,   430,   434,   437,   438,
     440,   452,   453,   455,   466,   467,   473,   474,   481,   497,
     511,   513,   515,   517,   519,   521,   523,   525,   527,   530,
     533,   536,   539,   542,   545,   548,   551,   554,   557,   561,
     565,   567,   570,   573,   575,   578,   581,   584,   586,   589,
     590,   592,   593,   596,   597,   601,   603,   607,   609,   613,
     615,   617,   619,   620,   623,   624,   627,   628,   631,   632,
     635,   637,   638,   640,   644,   646,   648,   650,   652,   657,
     662,   664,   667,   668,   672,   674,   676,   678,   679,   683,
     685,   690,   695,   699,   702,   703,   705,   706,   709,   711,
     716,   719,   722,   724,   726,   729,   731,   733,   736,   738,
     740,   742,   745,   747,   749,   751,   753,   755,   757,   759,
     761,   763,   767,   768,   773,   774,   776
};
static const short yyrhs[] =
{
     109,     0,   108,   109,     0,     0,   110,   111,     0,   135,
       0,   141,     0,   137,     0,   138,     0,   139,     0,   125,
       0,   120,     0,   124,     0,   133,     0,   134,     0,   142,
       0,   144,     0,   145,     0,   147,     0,   148,     0,   149,
       0,   150,     0,   151,     0,   152,     0,   113,     0,   112,
       0,   129,     0,   132,     0,   117,     0,   173,     0,   175,
       0,   172,     0,   171,     0,   154,     0,   188,     0,   208,
       0,     0,    15,   213,   114,    86,   115,    87,    88,     0,
     116,     0,   115,   116,     0,   143,     0,    26,   153,     0,
      27,   153,     0,     0,    74,    19,   118,    86,   119,    87,
      88,     0,   112,     0,   119,   112,     0,     0,    76,   121,
      86,   122,    87,     0,   123,     0,   122,   123,     0,    19,
       0,    77,    19,     0,     0,    75,   126,    86,   127,    87,
       0,   128,     0,   127,   128,     0,    19,     0,    17,    89,
     131,    90,     0,    19,     0,    91,    19,     0,   130,    62,
      19,     0,   130,    62,    91,    19,     0,   130,     0,   157,
      92,   157,     0,    18,     0,    78,   192,     0,    79,    19,
       0,    36,    19,   136,     0,     0,    71,     0,    29,    20,
       0,    30,    20,     0,    31,    20,     0,     0,     6,   153,
       0,     7,   153,     0,    14,   153,     0,    33,   153,     0,
      32,   153,     0,    34,   153,     0,    32,   153,     0,    35,
     153,     0,    10,   153,     0,     9,   153,     0,    11,   153,
       0,     9,   153,     0,     8,   153,     0,    12,   153,     0,
      13,   153,     0,     3,   153,     0,     4,   153,     0,     5,
      20,   156,   153,     0,    16,    18,     0,     0,    59,   157,
     155,    86,   158,    87,    88,     0,     0,    20,     0,     0,
      19,     0,     0,   159,     0,   160,     0,   159,   160,     0,
     129,     0,   132,     0,    19,   162,   161,     0,     0,    93,
       0,     0,    94,   163,     0,   166,     0,   163,   164,   166,
       0,    92,     0,    95,     0,    96,     0,     0,    91,     0,
      97,     0,    92,     0,    95,     0,   165,   169,     0,   168,
       0,   167,    61,   168,     0,    19,     0,   167,     0,   167,
      89,   170,    90,     0,    72,     0,    71,     0,    81,     0,
      82,     0,    21,     0,    80,     0,     0,   166,     0,   170,
      93,   166,     0,    73,   209,    19,    88,     0,    37,   167,
      88,     0,     0,    38,    19,   174,   192,    86,   180,    87,
      88,     0,     0,    37,    19,   176,   177,   192,    86,   180,
      87,    88,     0,     0,    98,   178,     0,   179,     0,   178,
      93,   179,     0,   167,     0,   181,     0,   180,   181,     0,
     129,     0,   132,     0,   117,     0,   173,     0,   175,     0,
     172,     0,   171,     0,   154,     0,   146,     0,   143,     0,
     185,     0,   183,     0,   203,     0,    28,   153,     0,    27,
     153,     0,    39,   182,    98,     0,    40,   182,    98,     0,
      41,   182,    98,     0,    42,    98,     0,     0,    43,     0,
     184,    97,    19,    89,    90,   215,    88,   196,   197,   198,
     199,     0,     0,    58,     0,    19,    89,   200,    90,   215,
     192,   186,    88,   196,   197,     0,     0,    99,    89,   200,
      90,   100,     0,     0,    99,   209,    89,   200,    90,   100,
       0,   209,    19,    89,   200,    90,   190,   215,   191,   192,
     187,    88,   196,   197,   198,   199,     0,   209,    83,   189,
      89,   200,    90,   190,   215,   192,   187,    88,   196,   197,
       0,    95,     0,    92,     0,   101,     0,   102,     0,   103,
       0,   104,     0,    96,     0,   105,     0,   106,   106,     0,
     107,   107,     0,    95,    94,     0,    92,    94,     0,   101,
      94,     0,   102,    94,     0,   103,    94,     0,   104,    94,
       0,    96,    94,     0,   105,    94,     0,   106,   106,    94,
       0,   107,   107,    94,     0,    97,     0,    89,    90,     0,
      99,   100,     0,   106,     0,   106,    94,     0,    94,    94,
       0,    91,    94,     0,   107,     0,   107,    94,     0,     0,
      63,     0,     0,    94,    71,     0,     0,   102,   193,   102,
       0,   194,     0,   193,    93,   194,     0,    19,     0,    19,
      94,   195,     0,    19,     0,    21,     0,    71,     0,     0,
      24,   153,     0,     0,    25,   153,     0,     0,    22,   153,
       0,     0,    23,   153,     0,   201,     0,     0,   202,     0,
     201,    93,   202,     0,    65,     0,    66,     0,    67,     0,
      68,     0,    69,    89,   200,    90,     0,    70,    89,   200,
      90,     0,    85,     0,   210,   162,     0,     0,    64,   204,
     205,     0,   205,     0,   206,     0,   208,     0,     0,    58,
     207,   188,     0,   188,     0,   209,    19,    88,   140,     0,
      63,   213,   212,   211,     0,   213,   212,   211,     0,   209,
     192,     0,     0,   104,     0,     0,   212,   101,     0,   167,
       0,   167,   106,   214,   107,     0,    38,   167,     0,    60,
      45,     0,    45,     0,    60,     0,    60,    46,     0,    46,
       0,    47,     0,    60,    47,     0,    48,     0,    49,     0,
      44,     0,    60,    50,     0,    50,     0,    51,     0,    52,
       0,    53,     0,    54,     0,    55,     0,    56,     0,    57,
       0,   209,     0,   214,    93,   209,     0,     0,    84,    89,
     216,    90,     0,     0,   167,     0,   216,    93,   167,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   250,   251,   254,   254,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   287,   288,   292,   293,
     294,   295,   296,   297,   298,   299,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   314,   314,   337,   338,
     341,   345,   354,   365,   365,   386,   387,   390,   390,   417,
     418,   421,   426,   431,   431,   457,   458,   461,   466,   481,
     484,   487,   490,   495,   496,   501,   507,   534,   557,   570,
     573,   576,   581,   586,   591,   594,   597,   603,   609,   612,
     618,   621,   627,   634,   637,   643,   646,   652,   658,   666,
     674,   680,   685,   709,   712,   712,   723,   726,   731,   734,
     739,   740,   743,   744,   747,   748,   749,   776,   777,   780,
     783,   788,   789,   807,   810,   813,   818,   821,   824,   827,
     830,   835,   853,   854,   859,   864,   874,   884,   888,   892,
     896,   900,   904,   910,   915,   921,   939,   945,   959,   959,
     982,   982,  1005,  1006,  1009,  1010,  1013,  1028,  1029,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1044,  1048,
    1049,  1050,  1051,  1062,  1073,  1077,  1081,  1085,  1091,  1094,
    1099,  1137,  1140,  1145,  1158,  1161,  1168,  1171,  1179,  1194,
    1206,  1207,  1208,  1209,  1210,  1211,  1212,  1213,  1214,  1215,
    1216,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1237,
    1240,  1245,  1248,  1256,  1259,  1265,  1269,  1281,  1285,  1291,
    1295,  1299,  1305,  1308,  1313,  1316,  1322,  1325,  1330,  1333,
    1339,  1387,  1392,  1398,  1428,  1435,  1442,  1449,  1456,  1466,
    1476,  1481,  1487,  1487,  1488,  1491,  1492,  1495,  1495,  1496,
    1499,  1520,  1525,  1532,  1585,  1588,  1593,  1596,  1601,  1605,
    1615,  1619,  1622,  1625,  1628,  1631,  1634,  1637,  1640,  1643,
    1646,  1649,  1652,  1655,  1658,  1661,  1664,  1667,  1670,  1673,
    1678,  1684,  1702,  1705,  1720,  1726,  1733
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "TK_DOC", "TK_EXPORTEDDOC", "TK_MAKEFILE", 
  "TK_ACCESSCODE", "TK_VARCODE", "TK_POSTINITCODE", "TK_CPPCODE", 
  "TK_MODCODE", "TK_TYPECODE", "TK_PREPYCODE", "TK_PYCODE", "TK_COPYING", 
  "TK_MAPPEDTYPE", "TK_CODEBLOCK", "TK_IF", "TK_END", "TK_NAME", 
  "TK_PATHNAME", "TK_STRING", "TK_VIRTUALCATCHERCODE", "TK_VIRTUALCODE", 
  "TK_METHODCODE", "TK_MEMBERCODE", "TK_FROMTYPE", "TK_TOTYPE", 
  "TK_TOSUBCLASS", "TK_INCLUDE", "TK_OPTINCLUDE", "TK_IMPORT", 
  "TK_HEADERCODE", "TK_MODHEADERCODE", "TK_TYPEHEADERCODE", 
  "TK_EXPHEADERCODE", "TK_MODULE", "TK_CLASS", "TK_STRUCT", "TK_PUBLIC", 
  "TK_PROTECTED", "TK_PRIVATE", "TK_SIGNALS", "TK_SLOTS", "TK_BOOL", 
  "TK_SHORT", "TK_INT", "TK_LONG", "TK_FLOAT", "TK_DOUBLE", "TK_CHAR", 
  "TK_VOID", "TK_PYOBJECT", "TK_PYTUPLE", "TK_PYLIST", "TK_PYDICT", 
  "TK_PYCALLABLE", "TK_PYSLICE", "TK_VIRTUAL", "TK_ENUM", "TK_UNSIGNED", 
  "TK_SCOPE", "TK_LOGICAL_OR", "TK_CONST", "TK_STATIC", "TK_SIPSIGNAL", 
  "TK_SIPSLOT", "TK_SIPRXCON", "TK_SIPRXDIS", "TK_SIPSLOTCON", 
  "TK_SIPSLOTDIS", "TK_NUMBER", "TK_REAL", "TK_TYPEDEF", "TK_NAMESPACE", 
  "TK_TIMELINE", "TK_PLATFORMS", "TK_FEATURE", "TK_LICENSE", "TK_EXPOSE", 
  "TK_QCHAR", "TK_TRUE", "TK_FALSE", "TK_OPERATOR", "TK_THROW", 
  "TK_QOBJECT", "'{'", "'}'", "';'", "'('", "')'", "'!'", "'-'", "','", 
  "'='", "'+'", "'|'", "'~'", "':'", "'['", "']'", "'*'", "'/'", "'%'", 
  "'&'", "'^'", "'<'", "'>'", "specification", "statement", "@1", 
  "modstatement", "nsstatement", "mappedtype", "@2", "mtbody", "mtline", 
  "namespace", "@3", "nsbody", "platforms", "@4", "platformlist", 
  "platform", "feature", "timeline", "@5", "qualifierlist", 
  "qualifiername", "ifstart", "oredqualifiers", "qualifiers", "ifend", 
  "license", "expose", "module", "optnumber", "include", "optinclude", 
  "import", "optaccesscode", "copying", "modhdrcode", "typehdrcode", 
  "exphdrcode", "modcode", "typecode", "postinitcode", "prepycode", 
  "pycode", "doc", "exporteddoc", "makefile", "codeblock", "enum", "@6", 
  "optfilename", "optname", "optenumbody", "enumbody", "enumline", 
  "optcomma", "optassign", "expr", "binop", "optunop", "value", 
  "scopedname", "scopepart", "simplevalue", "valuelist", "typedef", 
  "opaqueclass", "struct", "@7", "class", "@8", "superclasses", 
  "superlist", "superclass", "classbody", "classline", "optslot", "dtor", 
  "optvirtual", "ctor", "optctorsig", "optsig", "function", 
  "operatorname", "optconst", "optabstract", "optflags", "flaglist", 
  "flag", "flagvalue", "methodcode", "membercode", "virtualcatchercode", 
  "virtualcode", "arglist", "rawarglist", "argvalue", "varmember", "@9", 
  "varmem", "member", "@10", "variable", "cpptype", "argtype", "optref", 
  "deref", "basetype", "cpptypelist", "optexceptions", "exceptionlist", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,   108,   108,   110,   109,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   114,   113,   115,   115,
     116,   116,   116,   118,   117,   119,   119,   121,   120,   122,
     122,   123,   124,   126,   125,   127,   127,   128,   129,   130,
     130,   130,   130,   131,   131,   132,   133,   134,   135,   136,
     136,   137,   138,   139,   140,   140,   140,   141,   142,   142,
     143,   143,   144,   145,   145,   146,   146,   147,   148,   149,
     150,   151,   152,   153,   155,   154,   156,   156,   157,   157,
     158,   158,   159,   159,   160,   160,   160,   161,   161,   162,
     162,   163,   163,   164,   164,   164,   165,   165,   165,   165,
     165,   166,   167,   167,   168,   169,   169,   169,   169,   169,
     169,   169,   169,   170,   170,   170,   171,   172,   174,   173,
     176,   175,   177,   177,   178,   178,   179,   180,   180,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   182,   182,
     183,   184,   184,   185,   186,   186,   187,   187,   188,   188,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   190,
     190,   191,   191,   192,   192,   193,   193,   194,   194,   195,
     195,   195,   196,   196,   197,   197,   198,   198,   199,   199,
     200,   201,   201,   201,   202,   202,   202,   202,   202,   202,
     202,   202,   204,   203,   203,   205,   205,   207,   206,   206,
     208,   209,   209,   210,   211,   211,   212,   212,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     214,   214,   215,   215,   216,   216,   216
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     2,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     7,     1,     2,
       1,     2,     2,     0,     7,     1,     2,     0,     5,     1,
       2,     1,     2,     0,     5,     1,     2,     1,     4,     1,
       2,     3,     4,     1,     3,     1,     2,     2,     3,     0,
       1,     2,     2,     2,     0,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     4,     2,     0,     7,     0,     1,     0,     1,
       0,     1,     1,     2,     1,     1,     3,     0,     1,     0,
       2,     1,     3,     1,     1,     1,     0,     1,     1,     1,
       1,     2,     1,     3,     1,     1,     4,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     4,     3,     0,     8,
       0,     9,     0,     2,     1,     3,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     3,     3,     3,     2,     0,     1,
      11,     0,     1,    10,     0,     5,     0,     6,    15,    13,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       1,     2,     2,     1,     2,     2,     2,     1,     2,     0,
       1,     0,     2,     0,     3,     1,     3,     1,     3,     1,
       1,     1,     0,     2,     0,     2,     0,     2,     0,     2,
       1,     0,     1,     3,     1,     1,     1,     1,     4,     4,
       1,     2,     0,     3,     1,     1,     1,     0,     3,     1,
       4,     4,     3,     2,     0,     1,     0,     2,     1,     4,
       2,     2,     1,     1,     2,     1,     1,     2,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     0,     4,     0,     1,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       3,     3,     1,     0,     2,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    65,   124,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   270,   262,   265,
     266,   268,   269,   272,   273,   274,   275,   276,   277,   278,
     279,    98,   263,     0,     0,     0,    53,    47,     0,   213,
       0,     4,    25,    24,    28,    11,    12,    10,    26,    27,
      13,    14,     5,     7,     8,     9,     6,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    33,   258,   122,    32,
      31,    29,    30,    34,    35,     0,   256,     0,    90,    91,
      96,    87,    84,    83,    88,    89,    77,     0,    36,    98,
      71,    72,    73,    79,    78,    82,    69,   140,     0,   124,
     260,    99,    94,   261,   264,   267,   271,   256,     0,    43,
       0,     0,    52,     0,    66,    67,     0,     0,     0,     0,
     254,    93,    97,     0,     0,    59,     0,    63,     0,     0,
      70,    68,   142,   137,   213,     0,   254,     0,     0,     0,
       0,   217,     0,   215,   123,   280,     0,    74,   231,     0,
       0,   181,     0,   180,   186,   200,     0,   182,   183,   184,
     185,   187,   203,   207,     0,   257,   255,   252,    92,     0,
      60,     0,    58,    98,     0,   213,     0,   100,   251,   136,
       0,    57,     0,    55,    51,     0,    49,     0,     0,   214,
       0,   259,     0,     0,   250,   234,   235,   236,   237,     0,
       0,   240,     0,   230,   232,   213,   109,   201,   206,   191,
     205,   190,   196,   202,   192,   193,   194,   195,   197,   204,
     188,   208,   189,   231,     0,     0,     0,     0,     0,    38,
      40,    61,     0,    64,   146,   143,   144,     0,   171,   109,
     104,   105,     0,   101,   102,    45,     0,    54,    56,    48,
      50,   219,   220,   221,   218,   216,   281,    75,    76,   231,
     231,   209,     0,   253,   116,   241,   198,   199,     0,    41,
      42,    81,    80,     0,    39,    62,     0,   171,     0,     0,
     124,     0,     0,   168,   168,   168,     0,   247,   242,   151,
     149,   150,   158,   157,   156,   155,   154,   152,   153,   171,
     147,   160,     0,   159,   249,   161,   244,   245,   246,   107,
       0,   103,     0,    46,     0,     0,   210,   282,   233,   117,
     119,   120,   118,   110,     0,   111,   209,    37,   145,   171,
      86,    85,   231,   163,   162,   169,     0,     0,     0,   167,
       0,     0,     0,   148,     0,   108,   106,    95,    44,   238,
     239,     0,   211,   113,   114,   115,   116,   131,   128,   127,
     132,   129,   130,   125,   121,   282,     0,     0,   164,   165,
     166,   248,     0,   247,   243,   139,     0,   284,     0,   213,
     112,   116,   213,   141,   282,     0,     0,   285,     0,   212,
     176,   134,     0,   176,   213,   282,   283,     0,     0,     0,
     126,   116,     0,   174,     0,   286,     0,   222,   135,   222,
       0,     0,   222,   231,     0,   224,   224,   231,   222,   224,
       0,   223,     0,   226,   179,     0,   224,   226,     0,   225,
       0,   228,     0,   173,   228,   177,   227,     0,   178,   175,
     170,   229,     0,     0
};

static const short yydefgoto[] =
{
       1,     2,     3,    51,    52,    53,   134,   238,   239,   299,
     148,   256,    55,   121,   195,   196,    56,    57,   120,   192,
     193,   300,   137,   138,   301,    60,    61,    62,   141,    63,
      64,    65,   204,    66,    67,   302,    68,    69,   303,    70,
      71,    72,    73,    74,    75,    88,   304,   145,   133,   112,
     252,   253,   254,   356,   275,   333,   366,   334,   335,    77,
      78,   374,   402,   305,   306,   307,   144,   308,   142,   185,
     245,   246,   309,   310,   346,   311,   312,   313,   421,   409,
     314,   174,   327,   389,   124,   152,   153,   264,   425,   433,
     441,   448,   212,   213,   214,   315,   351,   316,   317,   350,
     318,    85,   216,   177,   130,    86,   156,   362,   398
};

static const short yypact[] =
{
  -32768,    76,-32768,   287,-32768,    78,    78,    90,    78,    78,
      78,    78,    78,    78,   620,    40,-32768,-32768,   140,   144,
     166,    78,    78,    78,    95,   159,   170,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   172,   194,   620,   600,   180,-32768,-32768,   183,   105,
     196,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,   -25,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,    25,-32768,   203,-32768,-32768,
     207,-32768,-32768,-32768,-32768,-32768,-32768,   204,-32768,    -1,
  -32768,-32768,-32768,-32768,-32768,-32768,   171,    30,    32,   -45,
     182,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   226,-32768,
     160,   161,-32768,   229,-32768,-32768,   204,   600,    36,   590,
     -64,-32768,-32768,    78,   163,   165,   231,   189,   162,   167,
  -32768,-32768,   157,-32768,   105,   174,   -64,   173,   177,   239,
     243,   187,    81,-32768,-32768,-32768,   -11,    92,   451,   175,
     190,   193,   195,   199,   200,-32768,   164,   209,   214,   215,
     216,   217,   -56,   -59,   181,-32768,-32768,-32768,-32768,   158,
  -32768,     9,-32768,   172,   204,   105,   202,   176,-32768,-32768,
     561,-32768,    10,-32768,-32768,    15,-32768,    59,   229,-32768,
     600,-32768,    78,    78,-32768,-32768,-32768,-32768,-32768,   223,
     224,-32768,   208,   221,-32768,   105,   232,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     233,-32768,   234,   451,    78,    78,    78,    78,   129,-32768,
  -32768,-32768,   247,-32768,   182,   236,-32768,   244,   513,   232,
  -32768,-32768,   258,   176,-32768,-32768,    14,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   451,
     451,   286,   451,-32768,   141,-32768,-32768,-32768,   261,-32768,
  -32768,-32768,-32768,   264,-32768,-32768,   204,   513,    78,    78,
     265,    78,    78,   310,   310,   310,   257,   259,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    94,
  -32768,-32768,   260,-32768,-32768,-32768,-32768,-32768,-32768,   266,
     270,-32768,   279,-32768,   278,   280,-32768,   285,-32768,-32768,
  -32768,-32768,-32768,   -53,    35,-32768,   286,-32768,-32768,   405,
  -32768,-32768,   451,-32768,-32768,-32768,   274,   277,   281,-32768,
     600,   352,   288,-32768,   358,-32768,-32768,-32768,-32768,-32768,
  -32768,   289,   290,-32768,-32768,-32768,   141,-32768,-32768,-32768,
  -32768,-32768,-32768,    98,-32768,   285,   292,   291,-32768,-32768,
  -32768,-32768,    26,-32768,-32768,-32768,   293,   204,   312,   105,
  -32768,   127,   105,-32768,   285,   296,   297,   182,    82,-32768,
     294,-32768,    87,   294,   105,   285,-32768,   204,   600,   298,
  -32768,   141,   301,   314,   303,   182,   306,   387,-32768,   387,
     328,   331,   387,   451,    78,   395,   395,   451,   387,   395,
     335,-32768,    78,   399,-32768,   337,   395,   399,   329,-32768,
      78,   407,   336,-32768,   407,-32768,-32768,    78,-32768,-32768,
  -32768,-32768,   428,-32768
};

static const short yypgoto[] =
{
  -32768,   430,-32768,-32768,  -170,-32768,-32768,-32768,   197,    11,
  -32768,-32768,-32768,-32768,-32768,   245,-32768,-32768,-32768,-32768,
     246,    16,-32768,-32768,    18,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,  -149,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,    -6,    19,-32768,-32768,   -88,
  -32768,-32768,   213,-32768,   218,-32768,-32768,-32768,  -229,   -13,
     322,-32768,-32768,    20,    21,    22,-32768,    23,-32768,-32768,
  -32768,   185,   186,  -254,   -69,-32768,-32768,-32768,-32768,    69,
      -2,-32768,   138,-32768,  -136,-32768,   282,-32768,  -249,  -260,
      38,    33,  -223,-32768,   210,-32768,-32768,   125,-32768,-32768,
      24,   -35,-32768,   338,   364,    61,-32768,  -322,-32768
};


#define	YYLAST		697


static const short yytable[] =
{
      89,    83,    91,    92,    93,    94,    95,    96,   186,   118,
     278,   139,   108,   110,    54,   103,   104,   105,   135,    58,
     255,    59,    76,    79,    80,    81,    82,    84,   241,   191,
     240,    15,    16,    17,   194,   231,   126,   175,   229,   363,
     176,  -138,   364,   365,   128,   395,   324,   325,   232,   247,
     230,    25,    26,   392,    17,   353,   367,  -138,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   404,    41,    42,    98,   452,    43,   261,   273,
     262,   127,   200,   414,   110,   353,   323,    44,    45,   240,
     136,  -124,   155,   126,    87,   243,   201,   257,   202,   203,
     242,   322,   259,   288,   117,   289,   368,   369,   129,   129,
      90,    15,    16,   290,   106,   370,   371,   372,  -124,   377,
     143,   291,   292,   215,   157,   158,   236,   178,   237,    99,
     263,    25,    26,   293,   294,   295,   296,   390,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   297,    41,    42,   234,   235,    43,   298,   126,
     100,   236,   401,   237,   101,   266,   434,    44,    45,   437,
     426,   244,   406,   429,   198,   407,   443,   410,   107,   436,
     411,   352,   418,   199,   234,   235,   102,   391,    83,   109,
     236,   111,   237,    15,    16,   249,   267,   268,   215,   119,
     430,    54,   122,   250,   435,   251,    58,   123,    59,    76,
      79,    80,    81,    82,    84,   125,   283,  -133,   329,   330,
    -133,   131,   331,    17,   332,   347,   348,   132,   279,   280,
     281,   282,   329,   330,   215,   215,   331,   215,   332,   113,
     114,   115,   140,   126,   116,   147,   149,   150,   151,   179,
     180,   181,   182,   400,    83,   184,   403,   -99,   191,   183,
     187,   189,   194,   190,   223,   217,   285,    54,   413,   250,
     233,   251,    58,   244,    59,    76,    79,    80,    81,    82,
      84,   197,   340,   341,   218,   343,   344,   219,   248,   220,
       5,     6,     7,   221,   222,     8,     9,    10,   271,    11,
      12,    13,    14,   224,    15,    16,    17,   215,   225,   226,
     227,   228,   269,   270,   272,   382,    18,    19,    20,    21,
      22,   373,    23,    24,    25,    26,   274,   276,   277,   286,
     287,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,   320,    41,    42,   381,   326,
      43,   336,   337,   345,   342,   349,  -172,   354,   357,   355,
      44,    45,    46,    47,    48,    49,    50,   358,   359,   361,
     360,    17,   378,   416,   397,   379,   385,   386,   387,   380,
     393,   394,   396,   399,   388,   158,   417,   405,   215,   419,
      97,   422,   215,   408,   415,   423,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     383,   424,    42,   420,   288,    43,   289,   427,   431,   428,
     432,   440,    15,    16,   290,   438,   439,   442,   453,   445,
     447,     4,   291,   292,   446,   284,   449,   236,   258,   237,
     260,   451,    25,    26,   293,   294,   295,   296,   154,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,   297,    41,    42,   321,   319,    43,   298,
      17,   338,   412,   339,   375,   444,   384,   450,    44,    45,
     265,   146,   328,     0,   188,     0,     0,     0,     0,    97,
       0,     0,   376,     0,     0,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,     0,
       0,    42,     0,     0,    43,     0,   205,   206,   207,   208,
     209,   210,   288,     0,   289,     0,     0,     0,     0,     0,
      15,    16,   290,     0,     0,     0,   211,     0,     0,     0,
     291,   292,     0,     0,     0,   236,     0,   237,     0,     0,
      25,    26,   293,   294,   295,   296,     0,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   297,    41,    42,     0,     0,    43,   298,    15,    16,
      17,     0,     0,     0,     0,     0,    44,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,     0,     0,     0,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    17,
      41,    42,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    44,    45,     0,     0,    97,    17,
       0,     0,     0,     0,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    97,     0,
      42,     0,     0,    43,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,     0,   159,
      42,   160,   161,     0,   162,   163,   164,   165,     0,   166,
       0,   167,   168,   169,   170,   171,   172,   173
};

static const short yycheck[] =
{
       6,     3,     8,     9,    10,    11,    12,    13,   144,    44,
     233,    99,    25,    26,     3,    21,    22,    23,    19,     3,
     190,     3,     3,     3,     3,     3,     3,     3,    19,    19,
     179,    17,    18,    19,    19,    94,    61,   101,    94,    92,
     104,    86,    95,    96,    19,    19,   269,   270,   107,   185,
     106,    37,    38,   375,    19,   309,    21,   102,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,   394,    59,    60,    14,     0,    63,    19,   215,
      21,   106,    93,   405,    97,   339,   256,    73,    74,   238,
      91,    61,   127,    61,    16,   183,   107,    87,     6,     7,
      91,    87,    87,     9,    43,    11,    71,    72,    83,    83,
      20,    17,    18,    19,    19,    80,    81,    82,    88,   342,
      88,    27,    28,   158,    88,    89,    32,   133,    34,    89,
      71,    37,    38,    39,    40,    41,    42,   366,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    26,    27,    63,    64,    61,
      20,    32,   391,    34,    20,   200,   426,    73,    74,   429,
     419,   184,    90,   422,    93,    93,   436,    90,    19,   428,
      93,    87,   411,   102,    26,    27,    20,    89,   190,    19,
      32,    19,    34,    17,    18,    19,   202,   203,   233,    19,
     423,   190,    19,   187,   427,   187,   190,   102,   190,   190,
     190,   190,   190,   190,   190,    19,    87,    90,    91,    92,
      93,    18,    95,    19,    97,   294,   295,    20,   234,   235,
     236,   237,    91,    92,   269,   270,    95,   272,    97,    45,
      46,    47,    71,    61,    50,    19,    86,    86,    19,    86,
      19,    62,    90,   389,   256,    98,   392,    92,    19,    92,
      86,    88,    19,    86,   100,    90,    19,   256,   404,   253,
      89,   253,   256,   286,   256,   256,   256,   256,   256,   256,
     256,    94,   288,   289,    94,   291,   292,    94,    86,    94,
       3,     4,     5,    94,    94,     8,     9,    10,    90,    12,
      13,    14,    15,    94,    17,    18,    19,   342,    94,    94,
      94,    94,    89,    89,    93,   350,    29,    30,    31,    32,
      33,   334,    35,    36,    37,    38,    94,    94,    94,    93,
      86,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    87,    59,    60,   350,    63,
      63,    90,    88,    43,    89,    98,    97,    97,    88,    93,
      73,    74,    75,    76,    77,    78,    79,    88,    90,    84,
      90,    19,    98,   408,   387,    98,    88,    19,    89,    98,
      88,    90,    89,    71,    94,    89,    88,    90,   423,    88,
      38,    88,   427,    99,   407,    89,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    24,    60,    99,     9,    63,    11,    89,   424,    88,
      25,    22,    17,    18,    19,    90,   432,    90,     0,   100,
      23,     1,    27,    28,   440,   238,   100,    32,   192,    34,
     195,   447,    37,    38,    39,    40,    41,    42,   126,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,   253,   249,    63,    64,
      19,   286,   403,   287,   336,   437,   351,   444,    73,    74,
     198,   117,   272,    -1,   146,    -1,    -1,    -1,    -1,    38,
      -1,    -1,    87,    -1,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    60,    -1,    -1,    63,    -1,    65,    66,    67,    68,
      69,    70,     9,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    85,    -1,    -1,    -1,
      27,    28,    -1,    -1,    -1,    32,    -1,    34,    -1,    -1,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    -1,    -1,    -1,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    19,
      59,    60,    -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    38,    19,
      -1,    -1,    -1,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    38,    -1,
      60,    -1,    -1,    63,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    89,
      60,    91,    92,    -1,    94,    95,    96,    97,    -1,    99,
      -1,   101,   102,   103,   104,   105,   106,   107
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || ((YYLTYPE_IS_TRIVIAL || ! YYLSP_NEEDED) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 319 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
YYPARSE_RETURN_TYPE yyparse (void *);
# else
YYPARSE_RETURN_TYPE yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

YYPARSE_RETURN_TYPE
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 254 "parser.y"
{
			/*
			 * We don't do these in parserEOF() because the parser
			 * is reading ahead and that would be too early.
			 */

			if (previousFile != NULL)
			{
				handleEOF();

				if (newContext.prevmod != NULL)
					handleEOM();

				free(previousFile);
				previousFile = NULL;
			}
	}
    break;
case 15:
#line 283 "parser.y"
{
			if (notSkipping() && isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> hdrcode,yyvsp[0].codeb);
		}
    break;
case 17:
#line 288 "parser.y"
{
			if (notSkipping() && isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> cppcode,yyvsp[0].codeb);
		}
    break;
case 36:
#line 314 "parser.y"
{
			if (notSkipping())
			{
				yyvsp[0].memArg.nrderefs = 0;
				yyvsp[0].memArg.argflags = 0;

				currentMappedType = newMappedType(currentSpec,&yyvsp[0].memArg);
				usedInMainModule(currentSpec,currentMappedType -> iff);
			}
		}
    break;
case 37:
#line 323 "parser.y"
{
			if (notSkipping())
			{
				if (currentMappedType -> convfromcode == NULL)
					yyerror("%MappedType must have a %ConvertFromTypeCode directive");

				if (currentMappedType -> convtocode == NULL)
					yyerror("%MappedType must have a %ConvertToTypeCode directive");

				currentMappedType = NULL;
			}
		}
    break;
case 40:
#line 341 "parser.y"
{
			if (notSkipping())
				appendCodeBlock(&currentMappedType -> hdrcode,yyvsp[0].codeb);
		}
    break;
case 41:
#line 345 "parser.y"
{
			if (notSkipping())
			{
				if (currentMappedType -> convfromcode != NULL)
					yyerror("%MappedType has more than one %ConvertFromTypeCode directive");

				currentMappedType -> convfromcode = yyvsp[0].codeb;
			}
		}
    break;
case 42:
#line 354 "parser.y"
{
			if (notSkipping())
			{
				if (currentMappedType -> convtocode != NULL)
					yyerror("%MappedType has more than one %ConvertToTypeCode directive");

				currentMappedType -> convtocode = yyvsp[0].codeb;
			}
		}
    break;
case 43:
#line 365 "parser.y"
{
			if (notSkipping())
			{
				classDef *ns;

				ns = newClass(currentSpec,namespace_iface,text2scopedName(yyvsp[0].text));
			
				setCannotCreate(ns);

				pushScope(ns);

				sectionFlags = 0;
			}
		}
    break;
case 44:
#line 378 "parser.y"
{
			/* Remove the namespace name. */

			if (notSkipping())
				popScope();
		}
    break;
case 47:
#line 390 "parser.y"
{
			qualDef *qd;

			for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
				if (qd -> qtype == platform_qualifier)
					yyerror("%Platforms has already been defined for this module");
		}
    break;
case 48:
#line 397 "parser.y"
{
			qualDef *qd;
			int nrneeded;

			/*
			 * Check that exactly one platform in the set was
			 * requested.
			 */

			nrneeded = 0;

			for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
				if (qd -> qtype == platform_qualifier && isNeeded(qd))
					++nrneeded;

			if (nrneeded != 1)
				yyerror("Exactly one of these %Platforms must be specified with the -t flag");
		}
    break;
case 51:
#line 421 "parser.y"
{
			newQualifier(currentSpec,currentModule,-1,yyvsp[0].text,platform_qualifier);
		}
    break;
case 52:
#line 426 "parser.y"
{
			newQualifier(currentSpec,currentModule,-1,yyvsp[0].text,feature_qualifier);
		}
    break;
case 53:
#line 431 "parser.y"
{
			if (currentModule -> nrTimeSlots >= 0)
				yyerror("%Timeline has already been defined for this module");

			currentModule -> nrTimeSlots = 0;
		}
    break;
case 54:
#line 437 "parser.y"
{
			qualDef *qd;
			int nrneeded;

			/*
			 * Check that exactly one time slot in the set was
			 * requested.
			 */

			nrneeded = 0;

			for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
				if (qd -> qtype == time_qualifier && isNeeded(qd))
					++nrneeded;

			if (nrneeded != 1)
				yyerror("Exactly one of this %Timeline must be specified with the -t flag");
		}
    break;
case 57:
#line 461 "parser.y"
{
			newQualifier(currentSpec,currentModule,currentModule -> nrTimeSlots++,yyvsp[0].text,time_qualifier);
		}
    break;
case 58:
#line 466 "parser.y"
{
			int skipNext;

			if (skipStackPtr >= MAX_NESTED_IF)
				yyerror("Internal error: increase the value of MAX_NESTED_IF");

			/* Nested %Ifs are implicit logical ands. */

			if (skipStackPtr > 0)
				yyvsp[-1].boolean = (yyvsp[-1].boolean && skipStack[skipStackPtr - 1]);

			skipStack[skipStackPtr++] = yyvsp[-1].boolean;
		}
    break;
case 59:
#line 481 "parser.y"
{
			yyval.boolean = platOrFeature(currentSpec,yyvsp[0].text,FALSE);
		}
    break;
case 60:
#line 484 "parser.y"
{
			yyval.boolean = platOrFeature(currentSpec,yyvsp[0].text,TRUE);
		}
    break;
case 61:
#line 487 "parser.y"
{
			yyval.boolean = (platOrFeature(currentSpec,yyvsp[0].text,FALSE) || yyvsp[-2].boolean);
		}
    break;
case 62:
#line 490 "parser.y"
{
			yyval.boolean = (platOrFeature(currentSpec,yyvsp[0].text,TRUE) || yyvsp[-3].boolean);
		}
    break;
case 64:
#line 496 "parser.y"
{
			yyval.boolean = timePeriod(currentSpec,yyvsp[-2].text,yyvsp[0].text);
		}
    break;
case 65:
#line 501 "parser.y"
{
			if (skipStackPtr-- <= 0)
				yyerror("Too many %End directives");
		}
    break;
case 66:
#line 507 "parser.y"
{
			optFlag *of;

			if (yyvsp[0].optflags.nrFlags == 0)
				yyerror("%License details not specified");

			if ((of = findOptFlag(&yyvsp[0].optflags,"Type",string_flag)) == NULL)
				yyerror("%License type not specified");

			currentModule -> license = sipMalloc(sizeof (licenseDef));

			currentModule -> license -> type = of -> fvalue.sval;

			currentModule -> license -> licensee = 
				((of = findOptFlag(&yyvsp[0].optflags,"Licensee",string_flag)) != NULL)
					? of -> fvalue.sval : NULL;

			currentModule -> license -> timestamp = 
				((of = findOptFlag(&yyvsp[0].optflags,"Timestamp",string_flag)) != NULL)
					? of -> fvalue.sval : NULL;

			currentModule -> license -> sig = 
				((of = findOptFlag(&yyvsp[0].optflags,"Signature",string_flag)) != NULL)
					? of -> fvalue.sval : NULL;
		}
    break;
case 67:
#line 534 "parser.y"
{
			/* Only bother if this is the main module. */

			if (isMainModule(currentModule))
			{
				expFuncDef *ef;

				/* Check it isn't already there. */

				for (ef = currentSpec -> exposed; ef != NULL; ef = ef -> next)
					if (strcmp(ef -> name,yyvsp[0].text) == 0)
						yyerror("Function has already been exposed in this module");

				ef = sipMalloc(sizeof (expFuncDef));

				ef -> name = yyvsp[0].text;
				ef -> next = currentSpec -> exposed;

				currentSpec -> exposed = ef;
			}
		}
    break;
case 68:
#line 557 "parser.y"
{
			/* Check the module hasn't already been defined. */

			moduleDef *mod;

			for (mod = currentSpec -> moduleList; mod != NULL; mod = mod -> next)
				if (mod -> name != NULL && strcmp(mod -> name,yyvsp[-1].text) == 0)
					yyerror("Module is already defined");

			currentModule -> name = yyvsp[-1].text;
		}
    break;
case 69:
#line 570 "parser.y"
{
			yyval.number = -1;
		}
    break;
case 71:
#line 576 "parser.y"
{
			parseFile(NULL,yyvsp[0].text,NULL,FALSE);
		}
    break;
case 72:
#line 581 "parser.y"
{
			parseFile(NULL,yyvsp[0].text,NULL,TRUE);
		}
    break;
case 73:
#line 586 "parser.y"
{
			newImport(currentSpec,yyvsp[0].text);
		}
    break;
case 74:
#line 591 "parser.y"
{
			yyval.codeb = NULL;
		}
    break;
case 75:
#line 594 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 76:
#line 597 "parser.y"
{
			yywarning("%VariableCode is renamed to %AccessCode in SIP v4 and later");
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 77:
#line 603 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> copying,yyvsp[0].codeb);
		}
    break;
case 78:
#line 609 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 79:
#line 612 "parser.y"
{
			yywarning("%HeaderCode is renamed to %ModuleHeaderCode in this context in SIP v4 and later");
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 80:
#line 618 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 81:
#line 621 "parser.y"
{
			yywarning("%HeaderCode is renamed to %TypeHeaderCode in this context in SIP v4 and later");
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 82:
#line 627 "parser.y"
{
			yywarning("%ExportedHeaderCode is deprecated");

			appendCodeBlock(&currentSpec -> exphdrcode,yyvsp[0].codeb);
		}
    break;
case 83:
#line 634 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 84:
#line 637 "parser.y"
{
			yywarning("%C++Code is renamed to %ModuleCode in this context in SIP v4 and later");
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 85:
#line 643 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 86:
#line 646 "parser.y"
{
			yywarning("%C++Code is renamed to %TypeCode in this context in SIP v4 and later");
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 87:
#line 652 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> postinitcode,yyvsp[0].codeb);
		}
    break;
case 88:
#line 658 "parser.y"
{
			yywarning("%PrePythonCode is deprecated");

			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> prepycode,yyvsp[0].codeb);
		}
    break;
case 89:
#line 666 "parser.y"
{
			yywarning("%PythonCode is deprecated");

			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> pycode,yyvsp[0].codeb);
		}
    break;
case 90:
#line 674 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> docs,yyvsp[0].codeb);
		}
    break;
case 91:
#line 680 "parser.y"
{
			appendCodeBlock(&currentSpec -> docs,yyvsp[0].codeb);
		}
    break;
case 92:
#line 685 "parser.y"
{
			if (isMainModule(currentModule))
			{
				mkTemplateDef *mtd;

				yywarning("%Makefile is deprecated, please use the -b flag instead");

				mtd = sipMalloc(sizeof (mkTemplateDef));

				mtd -> name = yyvsp[-2].text;

				if ((mtd -> objext = yyvsp[-1].text) == NULL)
					mtd -> objext = DEFAULT_OFILE_EXT;

				mtd -> templ = NULL;

				appendCodeBlock(&mtd -> templ,yyvsp[0].codeb);

				mtd -> next = currentSpec -> mktemplates;
				currentSpec -> mktemplates = mtd;
			}
		}
    break;
case 94:
#line 712 "parser.y"
{
			if (notSkipping())
			{
				if (sectionFlags != 0 && (sectionFlags & ~(SECT_IS_PUBLIC | SECT_IS_PROT)) != 0)
					yyerror("Class enums must be in the public or protected sections");

				currentEnum = newEnum(currentSpec,currentModule,yyvsp[0].text,sectionFlags);
			}
		}
    break;
case 96:
#line 723 "parser.y"
{
			yyval.text = NULL;
		}
    break;
case 97:
#line 726 "parser.y"
{
			yyval.text = yyvsp[0].text;
		}
    break;
case 98:
#line 731 "parser.y"
{
			yyval.text = NULL;
		}
    break;
case 99:
#line 734 "parser.y"
{
			yyval.text = yyvsp[0].text;
		}
    break;
case 106:
#line 749 "parser.y"
{
			if (notSkipping())
			{
				/*
				 * Note that we don't use the assigned value.
				 * This is a hangover from when enums where
				 * generated in Python.  We can remove it when
				 * we have got around to updating all the .sip
				 * files.
				 */

				enumValueDef *evd;

				evd = sipMalloc(sizeof (enumValueDef));

				evd -> name = cacheName(currentSpec,currentModule,yyvsp[-2].text);
				evd -> ed = currentEnum;

				checkAttributes(currentSpec,evd -> ed -> ecd,evd -> name,enum_attr);

				evd -> next = currentEnum -> values;
				currentEnum -> values = evd;

			}
		}
    break;
case 109:
#line 780 "parser.y"
{
			yyval.valp = NULL;
		}
    break;
case 110:
#line 783 "parser.y"
{
			yyval.valp = yyvsp[0].valp;
		}
    break;
case 112:
#line 789 "parser.y"
{
			valueDef *vd;
 
			if (yyvsp[-2].valp -> vtype == string_value || yyvsp[0].valp -> vtype == string_value)
				yyerror("Invalid binary operator for string");
 
			/* Find the last value in the existing expression. */
 
			for (vd = yyvsp[-2].valp; vd -> next != NULL; vd = vd -> next)
				;
 
			vd -> vbinop = yyvsp[-1].qchar;
			vd -> next = yyvsp[0].valp;

			yyval.valp = yyvsp[-2].valp;
		}
    break;
case 113:
#line 807 "parser.y"
{
			yyval.qchar = '-';
		}
    break;
case 114:
#line 810 "parser.y"
{
			yyval.qchar = '+';
		}
    break;
case 115:
#line 813 "parser.y"
{
			yyval.qchar = '|';
		}
    break;
case 116:
#line 818 "parser.y"
{
			yyval.qchar = '\0';
		}
    break;
case 117:
#line 821 "parser.y"
{
			yyval.qchar = '!';
		}
    break;
case 118:
#line 824 "parser.y"
{
			yyval.qchar = '~';
		}
    break;
case 119:
#line 827 "parser.y"
{
			yyval.qchar = '-';
		}
    break;
case 120:
#line 830 "parser.y"
{
			yyval.qchar = '+';
		}
    break;
case 121:
#line 835 "parser.y"
{
			if (yyvsp[-1].qchar != '\0' && yyvsp[0].value.vtype == string_value)
				yyerror("Invalid unary operator for string");
 
			/*
			 * Convert the value to a simple expression on the
			 * heap.
			 */
 
			yyval.valp = sipMalloc(sizeof (valueDef));
 
			*yyval.valp = yyvsp[0].value;
			yyval.valp -> vunop = yyvsp[-1].qchar;
			yyval.valp -> vbinop = '\0';
			yyval.valp -> next = NULL;
		}
    break;
case 123:
#line 854 "parser.y"
{
			appendScopedName(&yyvsp[-2].scpvalp,yyvsp[0].scpvalp);
		}
    break;
case 124:
#line 859 "parser.y"
{
			yyval.scpvalp = text2scopePart(yyvsp[0].text);
		}
    break;
case 125:
#line 864 "parser.y"
{
			/*
			 * We let the C++ compiler decide if the value is a
			 * valid one - no point in building a full C++ parser
			 * here.
			 */

			yyval.value.vtype = scoped_value;
			yyval.value.u.vscp = yyvsp[0].scpvalp;
		}
    break;
case 126:
#line 874 "parser.y"
{
			fcallDef *fcd;

			fcd = sipMalloc(sizeof (fcallDef));
			*fcd = yyvsp[-1].fcall;
			fcd -> name = yyvsp[-3].scpvalp;

			yyval.value.vtype = fcall_value;
			yyval.value.u.fcd = fcd;
		}
    break;
case 127:
#line 884 "parser.y"
{
			yyval.value.vtype = real_value;
			yyval.value.u.vreal = yyvsp[0].real;
		}
    break;
case 128:
#line 888 "parser.y"
{
			yyval.value.vtype = numeric_value;
			yyval.value.u.vnum = yyvsp[0].number;
		}
    break;
case 129:
#line 892 "parser.y"
{
			yyval.value.vtype = numeric_value;
			yyval.value.u.vnum = 1;
		}
    break;
case 130:
#line 896 "parser.y"
{
			yyval.value.vtype = numeric_value;
			yyval.value.u.vnum = 0;
		}
    break;
case 131:
#line 900 "parser.y"
{
			yyval.value.vtype = string_value;
			yyval.value.u.vstr = yyvsp[0].text;
		}
    break;
case 132:
#line 904 "parser.y"
{
			yyval.value.vtype = qchar_value;
			yyval.value.u.vqchar = yyvsp[0].qchar;
		}
    break;
case 133:
#line 910 "parser.y"
{
			/* No values. */

			yyval.fcall.nrArgs = 0;
		}
    break;
case 134:
#line 915 "parser.y"
{
			/* The single or first value. */

			yyval.fcall.args[0] = yyvsp[0].valp;
			yyval.fcall.nrArgs = 1;
		}
    break;
case 135:
#line 921 "parser.y"
{
			/* Check that it wasn't ...(,value...). */

			if (yyval.fcall.nrArgs == 0)
				yyerror("First argument to function call is missing");

			/* Check there is room. */

			if (yyvsp[-2].fcall.nrArgs == MAX_NR_ARGS)
				yyerror("Too many arguments to function call");

			yyval.fcall = yyvsp[-2].fcall;

			yyval.fcall.args[yyval.fcall.nrArgs] = yyvsp[0].valp;
			yyval.fcall.nrArgs++;
		}
    break;
case 136:
#line 939 "parser.y"
{
			if (notSkipping())
				newTypedef(currentSpec,yyvsp[-1].text,&yyvsp[-2].memArg);
		}
    break;
case 137:
#line 945 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd;

				cd = newClass(currentSpec,class_iface,yyvsp[-1].scpvalp);

				usedInMainModule(currentSpec,cd -> iff);
				setCannotCreate(cd);
				setIsOpaque(cd);
			}
		}
    break;
case 138:
#line 959 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd;

				cd = newClass(currentSpec,class_iface,text2scopedName(yyvsp[0].text));

				usedInMainModule(currentSpec,cd -> iff);
				setCannotCreate(cd);

				pushScope(cd);

				sectionFlags = SECT_IS_PUBLIC;
			}
		}
    break;
case 139:
#line 973 "parser.y"
{
			if (notSkipping())
			{
				finishClass(currentScope(),&yyvsp[-4].optflags);
				popScope();
			}
		}
    break;
case 140:
#line 982 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd;

				cd = newClass(currentSpec,class_iface,text2scopedName(yyvsp[0].text));

				usedInMainModule(currentSpec,cd -> iff);
				setCannotCreate(cd);

				pushScope(cd);

				sectionFlags = SECT_IS_PRIVATE;
			}
		}
    break;
case 141:
#line 996 "parser.y"
{
			if (notSkipping())
			{
				finishClass(currentScope(),&yyvsp[-4].optflags);
				popScope();
			}
		}
    break;
case 146:
#line 1013 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd, *super;

				cd = currentScope();

				super = findClass(currentSpec,class_iface,yyvsp[0].scpvalp);

				appendToClassList(&cd -> supers,super);
				addToUsedList(&cd -> iff -> used,super -> iff);
			}
		}
    break;
case 157:
#line 1040 "parser.y"
{
			if (notSkipping())
				appendCodeBlock(&currentScope() -> cppcode,yyvsp[0].codeb);
		}
    break;
case 158:
#line 1044 "parser.y"
{
			if (notSkipping())
				appendCodeBlock(&currentScope() -> hdrcode,yyvsp[0].codeb);
		}
    break;
case 162:
#line 1051 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd = currentScope();

				if (cd -> convtosubcode != NULL)
					yyerror("Class has more than one %ConvertToSubClassCode directive");

				cd -> convtosubcode = yyvsp[0].codeb;
			}
		}
    break;
case 163:
#line 1062 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd = currentScope();

				if (cd -> convtocode != NULL)
					yyerror("Class has more than one %ConvertToTypeCode directive");

				cd -> convtocode = yyvsp[0].codeb;
			}
		}
    break;
case 164:
#line 1073 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_PUBLIC | yyvsp[-1].number;
		}
    break;
case 165:
#line 1077 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_PROT | yyvsp[-1].number;
		}
    break;
case 166:
#line 1081 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_PRIVATE | yyvsp[-1].number;
		}
    break;
case 167:
#line 1085 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_SIGNAL;
		}
    break;
case 168:
#line 1091 "parser.y"
{
			yyval.number = 0;
		}
    break;
case 169:
#line 1094 "parser.y"
{
			yyval.number = SECT_IS_SLOT;
		}
    break;
case 170:
#line 1099 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd = currentScope();

				if (strcmp(classBaseName(cd),yyvsp[-8].text) != 0)
					yyerror("Destructor doesn't have the same name as its class");

				if (isDtor(cd))
					yyerror("Destructor has already been defined");

				if (yyvsp[-3].codeb != NULL && yyvsp[-2].codeb != NULL)
					yyerror("Cannot provide %MethodCode and %MemberCode");

				if (yyvsp[-3].codeb == NULL)
					yyvsp[-3].codeb = yyvsp[-2].codeb;

				if (yyvsp[-1].codeb != NULL && yyvsp[0].codeb != NULL)
					yyerror("Cannot provide %VirtualCatcherCode and %VirtualCode");

				if (yyvsp[-1].codeb == NULL)
					yyvsp[-1].codeb = yyvsp[0].codeb;

				cd -> dealloccode = yyvsp[-3].codeb;
				cd -> dtorcode = yyvsp[-1].codeb;
				cd -> dtorexceptions = yyvsp[-5].throwlist;
				cd -> classflags |= sectionFlags;

				/*
				 * Make the class complex if we have a virtual
				 * dtor or some dtor code.
				 */
				if (yyvsp[-10].number || yyvsp[-1].codeb != NULL)
					setIsComplex(cd);
			}
		}
    break;
case 171:
#line 1137 "parser.y"
{
			yyval.number = FALSE;
		}
    break;
case 172:
#line 1140 "parser.y"
{
			yyval.number = TRUE;
		}
    break;
case 173:
#line 1145 "parser.y"
{
			if (notSkipping())
			{
				if ((sectionFlags & (SECT_IS_PUBLIC | SECT_IS_PROT | SECT_IS_PRIVATE)) == 0)
					yyerror("Constructor must be in the public, private or protected sections");

				newCtor(yyvsp[-9].text,sectionFlags,&yyvsp[-7].arglist,&yyvsp[-4].optflags,yyvsp[-1].codeb,yyvsp[0].codeb,yyvsp[-5].throwlist,yyvsp[-3].optsignature);
			}

			free(yyvsp[-9].text);
		}
    break;
case 174:
#line 1158 "parser.y"
{
			yyval.optsignature = NULL;
		}
    break;
case 175:
#line 1161 "parser.y"
{
			yyval.optsignature = sipMalloc(sizeof (signatureDef));

			yyval.optsignature -> args = yyvsp[-2].arglist;
		}
    break;
case 176:
#line 1168 "parser.y"
{
			yyval.optsignature = NULL;
		}
    break;
case 177:
#line 1171 "parser.y"
{
			yyval.optsignature = sipMalloc(sizeof (signatureDef));

			yyval.optsignature -> result = yyvsp[-4].memArg;
			yyval.optsignature -> args = yyvsp[-2].arglist;
		}
    break;
case 178:
#line 1179 "parser.y"
{
			if (notSkipping())
			{
				if (sectionFlags != 0 && (sectionFlags & (SECT_IS_PUBLIC | SECT_IS_PROT | SECT_IS_PRIVATE | SECT_IS_SLOT | SECT_IS_SIGNAL)) == 0)
					yyerror("Class function must be in the public, private, protected, slot or signal sections");

				newFunction(currentSpec,currentModule,
					    sectionFlags,currentIsStatic,
					    currentOverIsVirt,
					    &yyvsp[-14].memArg,yyvsp[-13].text,&yyvsp[-11].arglist,yyvsp[-9].number,yyvsp[-7].number,&yyvsp[-6].optflags,yyvsp[-3].codeb,yyvsp[-2].codeb,yyvsp[-1].codeb,yyvsp[0].codeb,yyvsp[-8].throwlist,yyvsp[-5].optsignature);
			}

			currentIsStatic = FALSE;
			currentOverIsVirt = FALSE;
		}
    break;
case 179:
#line 1194 "parser.y"
{
			if (notSkipping())
				newFunction(currentSpec,currentModule,
					    sectionFlags,currentIsStatic,
					    currentOverIsVirt,
					    &yyvsp[-12].memArg,yyvsp[-10].text,&yyvsp[-8].arglist,yyvsp[-6].number,FALSE,&yyvsp[-4].optflags,yyvsp[-1].codeb,yyvsp[0].codeb,NULL,NULL,yyvsp[-5].throwlist,yyvsp[-3].optsignature);

			currentIsStatic = FALSE;
			currentOverIsVirt = FALSE;
		}
    break;
case 180:
#line 1206 "parser.y"
{yyval.text = "__add__";}
    break;
case 181:
#line 1207 "parser.y"
{yyval.text = "__sub__";}
    break;
case 182:
#line 1208 "parser.y"
{yyval.text = "__mul__";}
    break;
case 183:
#line 1209 "parser.y"
{yyval.text = "__div__";}
    break;
case 184:
#line 1210 "parser.y"
{yyval.text = "__mod__";}
    break;
case 185:
#line 1211 "parser.y"
{yyval.text = "__and__";}
    break;
case 186:
#line 1212 "parser.y"
{yyval.text = "__or__";}
    break;
case 187:
#line 1213 "parser.y"
{yyval.text = "__xor__";}
    break;
case 188:
#line 1214 "parser.y"
{yyval.text = "__lshift__";}
    break;
case 189:
#line 1215 "parser.y"
{yyval.text = "__rshift__";}
    break;
case 190:
#line 1216 "parser.y"
{yyval.text = "__iadd__";}
    break;
case 191:
#line 1217 "parser.y"
{yyval.text = "__isub__";}
    break;
case 192:
#line 1218 "parser.y"
{yyval.text = "__imul__";}
    break;
case 193:
#line 1219 "parser.y"
{yyval.text = "__idiv__";}
    break;
case 194:
#line 1220 "parser.y"
{yyval.text = "__imod__";}
    break;
case 195:
#line 1221 "parser.y"
{yyval.text = "__iand__";}
    break;
case 196:
#line 1222 "parser.y"
{yyval.text = "__ior__";}
    break;
case 197:
#line 1223 "parser.y"
{yyval.text = "__ixor__";}
    break;
case 198:
#line 1224 "parser.y"
{yyval.text = "__ilshift__";}
    break;
case 199:
#line 1225 "parser.y"
{yyval.text = "__irshift__";}
    break;
case 200:
#line 1226 "parser.y"
{yyval.text = "__invert__";}
    break;
case 201:
#line 1227 "parser.y"
{yyval.text = "__call__";}
    break;
case 202:
#line 1228 "parser.y"
{yyval.text = "__getitem__";}
    break;
case 203:
#line 1229 "parser.y"
{yyval.text = "__lt__";}
    break;
case 204:
#line 1230 "parser.y"
{yyval.text = "__le__";}
    break;
case 205:
#line 1231 "parser.y"
{yyval.text = "__eq__";}
    break;
case 206:
#line 1232 "parser.y"
{yyval.text = "__ne__";}
    break;
case 207:
#line 1233 "parser.y"
{yyval.text = "__gt__";}
    break;
case 208:
#line 1234 "parser.y"
{yyval.text = "__ge__";}
    break;
case 209:
#line 1237 "parser.y"
{
			yyval.number = FALSE;
		}
    break;
case 210:
#line 1240 "parser.y"
{
			yyval.number = TRUE;
		}
    break;
case 211:
#line 1245 "parser.y"
{
			yyval.number = 0;
		}
    break;
case 212:
#line 1248 "parser.y"
{
			if (yyvsp[0].number != 0)
				yyerror("Abstract virtual function '= 0' expected");

			yyval.number = TRUE;
		}
    break;
case 213:
#line 1256 "parser.y"
{
			yyval.optflags.nrFlags = 0;
		}
    break;
case 214:
#line 1259 "parser.y"
{
			yyval.optflags = yyvsp[-1].optflags;
		}
    break;
case 215:
#line 1265 "parser.y"
{
			yyval.optflags.flags[0] = yyvsp[0].flag;
			yyval.optflags.nrFlags = 1;
		}
    break;
case 216:
#line 1269 "parser.y"
{
			/* Check there is room. */

			if (yyvsp[-2].optflags.nrFlags == MAX_NR_FLAGS)
				yyerror("Too many optional flags");

			yyval.optflags = yyvsp[-2].optflags;

			yyval.optflags.flags[yyval.optflags.nrFlags++] = yyvsp[0].flag;
		}
    break;
case 217:
#line 1281 "parser.y"
{
			yyval.flag.ftype = bool_flag;
			yyval.flag.fname = yyvsp[0].text;
		}
    break;
case 218:
#line 1285 "parser.y"
{
			yyval.flag = yyvsp[0].flag;
			yyval.flag.fname = yyvsp[-2].text;
		}
    break;
case 219:
#line 1291 "parser.y"
{
			yyval.flag.ftype = name_flag;
			yyval.flag.fvalue.sval = yyvsp[0].text;
		}
    break;
case 220:
#line 1295 "parser.y"
{
			yyval.flag.ftype = string_flag;
			yyval.flag.fvalue.sval = yyvsp[0].text;
		}
    break;
case 221:
#line 1299 "parser.y"
{
			yyval.flag.ftype = integer_flag;
			yyval.flag.fvalue.ival = yyvsp[0].number;
		}
    break;
case 222:
#line 1305 "parser.y"
{
			yyval.codeb = NULL;
		}
    break;
case 223:
#line 1308 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 224:
#line 1313 "parser.y"
{
			yyval.codeb = NULL;
		}
    break;
case 225:
#line 1316 "parser.y"
{
			yywarning("%MemberCode is deprecated, please use %MethodCode instead");
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 226:
#line 1322 "parser.y"
{
			yyval.codeb = NULL;
		}
    break;
case 227:
#line 1325 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 228:
#line 1330 "parser.y"
{
			yyval.codeb = NULL;
		}
    break;
case 229:
#line 1333 "parser.y"
{
			yywarning("%VirtualCode is deprecated, please use %VirtualCatcherCode instead");
			yyval.codeb = yyvsp[0].codeb;
		}
    break;
case 230:
#line 1339 "parser.y"
{
			int a, nrrxcon, nrrxdis, nrslotcon, nrslotdis, nrarray, nrarraysize;

			nrrxcon = nrrxdis = nrslotcon = nrslotdis = nrarray = nrarraysize = 0;

			for (a = 0; a < yyvsp[0].arglist.nrArgs; ++a)
			{
				argDef *ad = &yyvsp[0].arglist.args[a];

				switch (ad -> atype)
				{
				case rxcon_type:
					++nrrxcon;
					break;

				case rxdis_type:
					++nrrxdis;
					break;

				case slotcon_type:
					++nrslotcon;
					break;

				case slotdis_type:
					++nrslotdis;
					break;
				}

				if (isArray(ad))
					++nrarray;

				if (isArraySize(ad))
					++nrarraysize;
			}

			if (nrrxcon != nrslotcon || nrrxcon > 1)
				yyerror("SIP_RXOBJ_CON and SIP_SLOT_CON must both be given and at most once");

			if (nrrxdis != nrslotdis || nrrxdis > 1)
				yyerror("SIP_RXOBJ_DIS and SIP_SLOT_DIS must both be given and at most once");

			if (nrarray != nrarraysize || nrarray > 1)
				yyerror("/Array/ and /ArraySize/ must both be given and at most once");

			yyval.arglist = yyvsp[0].arglist;
		}
    break;
case 231:
#line 1387 "parser.y"
{
			/* No arguments. */

			yyval.arglist.nrArgs = 0;
		}
    break;
case 232:
#line 1392 "parser.y"
{
			/* The single or first argument. */

			yyval.arglist.args[0] = yyvsp[0].memArg;
			yyval.arglist.nrArgs = 1;
		}
    break;
case 233:
#line 1398 "parser.y"
{
			/* Check that it wasn't ...(,arg...). */

			if (yyvsp[-2].arglist.nrArgs == 0)
				yyerror("First argument of list is missing");

			/*
			 * If this argument has no default value, then all
			 * previous ones mustn't either.
			 */

			if (yyvsp[0].memArg.defval == NULL)
			{
				int a;

				for (a = 0; a < yyvsp[-2].arglist.nrArgs; ++a)
					if (yyvsp[-2].arglist.args[a].defval != NULL)
						yyerror("Compulsory argument given after optional argument");
			}

			/* Check there is room. */

			if (yyvsp[-2].arglist.nrArgs == MAX_NR_ARGS)
				yyerror("Internal error - increase the value of MAX_NR_ARGS");

			yyval.arglist = yyvsp[-2].arglist;
			yyval.arglist.args[yyval.arglist.nrArgs++] = yyvsp[0].memArg;
		}
    break;
case 234:
#line 1428 "parser.y"
{
			yyval.memArg.atype = signal_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			currentSpec -> sigslots = TRUE;
		}
    break;
case 235:
#line 1435 "parser.y"
{
			yyval.memArg.atype = slot_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			currentSpec -> sigslots = TRUE;
		}
    break;
case 236:
#line 1442 "parser.y"
{
			yyval.memArg.atype = rxcon_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			currentSpec -> sigslots = TRUE;
		}
    break;
case 237:
#line 1449 "parser.y"
{
			yyval.memArg.atype = rxdis_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			currentSpec -> sigslots = TRUE;
		}
    break;
case 238:
#line 1456 "parser.y"
{
			yyval.memArg.atype = slotcon_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			yyval.memArg.u.sa = sipMalloc(sizeof (funcArgs));
			*yyval.memArg.u.sa = yyvsp[-1].arglist;

			currentSpec -> sigslots = TRUE;
		}
    break;
case 239:
#line 1466 "parser.y"
{
			yyval.memArg.atype = slotdis_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			yyval.memArg.u.sa = sipMalloc(sizeof (funcArgs));
			*yyval.memArg.u.sa = yyvsp[-1].arglist;

			currentSpec -> sigslots = TRUE;
		}
    break;
case 240:
#line 1476 "parser.y"
{
			yyval.memArg.atype = qobject_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;
		}
    break;
case 241:
#line 1481 "parser.y"
{
			yyval.memArg = yyvsp[-1].memArg;
			yyval.memArg.defval = yyvsp[0].valp;
		}
    break;
case 242:
#line 1487 "parser.y"
{currentIsStatic = TRUE;}
    break;
case 247:
#line 1495 "parser.y"
{currentOverIsVirt = TRUE;}
    break;
case 250:
#line 1499 "parser.y"
{
			if (notSkipping())
			{
				/* Check the section. */

				if (sectionFlags != 0)
				{
					if ((sectionFlags & SECT_IS_PUBLIC) == 0)
						yyerror("Class variables must be in the public section");

					if (!currentIsStatic && yyvsp[0].codeb != NULL)
						yyerror("%AccessCode cannot be specified for non-static class variables");
				}

				newVar(currentSpec,currentModule,yyvsp[-2].text,currentIsStatic,&yyvsp[-3].memArg,yyvsp[0].codeb);
			}

			currentIsStatic = FALSE;
		}
    break;
case 251:
#line 1520 "parser.y"
{
			yyval.memArg = yyvsp[-2].memArg;
			yyval.memArg.nrderefs = yyvsp[-1].number;
			yyval.memArg.argflags = ARG_IS_CONST | yyvsp[0].number;
		}
    break;
case 252:
#line 1525 "parser.y"
{
			yyval.memArg = yyvsp[-2].memArg;
			yyval.memArg.nrderefs = yyvsp[-1].number;
			yyval.memArg.argflags = yyvsp[0].number;
		}
    break;
case 253:
#line 1532 "parser.y"
{
			yyval.memArg = yyvsp[-1].memArg;

			if (findOptFlag(&yyvsp[0].optflags,"AllowNone",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_ALLOW_NONE;

			if (findOptFlag(&yyvsp[0].optflags,"GetWrapper",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_GET_WRAPPER;

			if (findOptFlag(&yyvsp[0].optflags,"Array",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_ARRAY;

			if (findOptFlag(&yyvsp[0].optflags,"ArraySize",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_ARRAY_SIZE;

			if (findOptFlag(&yyvsp[0].optflags,"Transfer",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_XFERRED;

			if (findOptFlag(&yyvsp[0].optflags,"TransferThis",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_THIS_XFERRED;

			if (findOptFlag(&yyvsp[0].optflags,"TransferBack",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_XFERRED_BACK;

			if (findOptFlag(&yyvsp[0].optflags,"In",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_IN;

			if (findOptFlag(&yyvsp[0].optflags,"Out",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_OUT;

			if (findOptFlag(&yyvsp[0].optflags,"Constrained",bool_flag) != NULL)
			{
				switch (yyval.memArg.atype)
				{
				case int_type:
					yyval.memArg.atype = cint_type;
					break;

				case float_type:
					yyval.memArg.atype = cfloat_type;
					break;

				case double_type:
					yyval.memArg.atype = cdouble_type;
					break;

				default:
					yyerror("/Constrained/ may not be specified for this type");
				}
			}
		}
    break;
case 254:
#line 1585 "parser.y"
{
			yyval.number = 0;
		}
    break;
case 255:
#line 1588 "parser.y"
{
			yyval.number = ARG_IS_REF;
		}
    break;
case 256:
#line 1593 "parser.y"
{
			yyval.number = 0;
		}
    break;
case 257:
#line 1596 "parser.y"
{
			yyval.number = yyvsp[-1].number + 1;
		}
    break;
case 258:
#line 1601 "parser.y"
{
			yyval.memArg.atype = defined_type;
			yyval.memArg.u.snd = yyvsp[0].scpvalp;
		}
    break;
case 259:
#line 1605 "parser.y"
{
			templateDef *td;

			td = sipMalloc(sizeof(templateDef));
			td -> fqname = yyvsp[-3].scpvalp;
			td -> types = yyvsp[-1].arglist;

			yyval.memArg.atype = template_type;
			yyval.memArg.u.td = td;
		}
    break;
case 260:
#line 1615 "parser.y"
{
			yyval.memArg.atype = struct_type;
			yyval.memArg.u.sname = yyvsp[0].scpvalp;
		}
    break;
case 261:
#line 1619 "parser.y"
{
			yyval.memArg.atype = ushort_type;
		}
    break;
case 262:
#line 1622 "parser.y"
{
			yyval.memArg.atype = short_type;
		}
    break;
case 263:
#line 1625 "parser.y"
{
			yyval.memArg.atype = uint_type;
		}
    break;
case 264:
#line 1628 "parser.y"
{
			yyval.memArg.atype = uint_type;
		}
    break;
case 265:
#line 1631 "parser.y"
{
			yyval.memArg.atype = int_type;
		}
    break;
case 266:
#line 1634 "parser.y"
{
			yyval.memArg.atype = long_type;
		}
    break;
case 267:
#line 1637 "parser.y"
{
			yyval.memArg.atype = ulong_type;
		}
    break;
case 268:
#line 1640 "parser.y"
{
			yyval.memArg.atype = float_type;
		}
    break;
case 269:
#line 1643 "parser.y"
{
			yyval.memArg.atype = double_type;
		}
    break;
case 270:
#line 1646 "parser.y"
{
			yyval.memArg.atype = bool_type;
		}
    break;
case 271:
#line 1649 "parser.y"
{
			yyval.memArg.atype = ustring_type;
		}
    break;
case 272:
#line 1652 "parser.y"
{
			yyval.memArg.atype = string_type;
		}
    break;
case 273:
#line 1655 "parser.y"
{
			yyval.memArg.atype = voidptr_type;
		}
    break;
case 274:
#line 1658 "parser.y"
{
			yyval.memArg.atype = pyobject_type;
		}
    break;
case 275:
#line 1661 "parser.y"
{
			yyval.memArg.atype = pytuple_type;
		}
    break;
case 276:
#line 1664 "parser.y"
{
			yyval.memArg.atype = pylist_type;
		}
    break;
case 277:
#line 1667 "parser.y"
{
			yyval.memArg.atype = pydict_type;
		}
    break;
case 278:
#line 1670 "parser.y"
{
			yyval.memArg.atype = pycallable_type;
		}
    break;
case 279:
#line 1673 "parser.y"
{
			yyval.memArg.atype = pyslice_type;
		}
    break;
case 280:
#line 1678 "parser.y"
{
			/* The single or first type. */

			yyval.arglist.args[0] = yyvsp[0].memArg;
			yyval.arglist.nrArgs = 1;
		}
    break;
case 281:
#line 1684 "parser.y"
{
			/* Check that it wasn't ,type... */

			if (yyval.arglist.nrArgs == 0)
				yyerror("First type of list is missing");

			/* Check there is room. */

			if (yyvsp[-2].arglist.nrArgs == MAX_NR_ARGS)
				yyerror("Internal error - increase the value of MAX_NR_ARGS");

			yyval.arglist = yyvsp[-2].arglist;

			yyval.arglist.args[yyval.arglist.nrArgs] = yyvsp[0].memArg;
			yyval.arglist.nrArgs++;
		}
    break;
case 282:
#line 1702 "parser.y"
{
			yyval.throwlist = NULL;
		}
    break;
case 283:
#line 1705 "parser.y"
{
			int e;

			/*
			 * Make sure the exceptions' header files are
			 * included.
			 */

			for (e = 0; e < yyvsp[-1].throwlist -> nrArgs; ++e)
				addToUsedList(&currentScope() -> iff -> used,yyvsp[-1].throwlist -> args[e] -> iff);

			yyval.throwlist = yyvsp[-1].throwlist;
		}
    break;
case 284:
#line 1720 "parser.y"
{
			/* Empty list so use a blank. */

			yyval.throwlist = sipMalloc(sizeof (throwArgs));
			yyval.throwlist -> nrArgs = 0;
		}
    break;
case 285:
#line 1726 "parser.y"
{
			/* The only or first exception. */

			yyval.throwlist = sipMalloc(sizeof (throwArgs));
			yyval.throwlist -> nrArgs = 1;
			yyval.throwlist -> args[0] = findClass(currentSpec,class_iface,yyvsp[0].scpvalp);
		}
    break;
case 286:
#line 1733 "parser.y"
{
			/* Check that it wasn't ...(,arg...). */

			if (yyvsp[-2].throwlist -> nrArgs == 0)
				yyerror("First exception of throw specifier is missing");

			/* Check there is room. */

			if (yyvsp[-2].throwlist -> nrArgs == MAX_NR_ARGS)
				yyerror("Internal error - increase the value of MAX_NR_ARGS");

			yyval.throwlist = yyvsp[-2].throwlist;
			yyval.throwlist -> args[yyval.throwlist -> nrArgs++] = findClass(currentSpec,class_iface,yyvsp[0].scpvalp);
		}
    break;
}

#line 709 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1749 "parser.y"



/*
 * Parse the specification.
 */

void parse(sipSpec *spec,FILE *fp,char *filename,char *cppMName,
	   stringList *tsl,stringList *xfl)
{
        /* Initialise the spec. */
 
	spec -> cppmname = cppMName;
	spec -> namecache = NULL;
	spec -> moduleList = NULL;
	spec -> ifacefiles = NULL;
	spec -> classes = NULL;
	spec -> mappedtypes = NULL;
	spec -> used = NULL;
	spec -> qobjclass = -1;
	spec -> exposed = NULL;
	spec -> enums = NULL;
	spec -> vars = NULL;
	spec -> othfuncs = NULL;
	spec -> overs = NULL;
	spec -> typedefs = NULL;
	spec -> copying = NULL;
	spec -> hdrcode = NULL;
	spec -> exphdrcode = NULL;
	spec -> cppcode = NULL;
	spec -> prepycode = NULL;
	spec -> pycode = NULL;
	spec -> docs = NULL;
	spec -> postinitcode = NULL;
	spec -> mktemplates = NULL;
	spec -> sigargs = NULL;
	spec -> sigslots = FALSE;

	currentSpec = spec;
	neededQualifiers = tsl;
	excludedQualifiers = xfl;
	currentModule = NULL;
	currentMappedType = NULL;
	currentOverIsVirt = FALSE;
	currentIsStatic = FALSE;
	previousFile = NULL;
	skipStackPtr = 0;
	currentScopeIdx = 0;
	sectionFlags = 0;

	newModule(fp,filename);
	spec -> module = currentModule;

	yyparse();

	handleEOF();
	handleEOM();
}


/*
 * Tell the parser that a complete file has now been read.
 */

void parserEOF(char *name,parserContext *pc)
{
	previousFile = sipStrdup(name);
	newContext = *pc;
}


/*
 * Append a class definition to a class list if it doesn't already exist.
 * Append is needed specifically for the list of super-classes because the
 * order is important to Python.
 */

static void appendToClassList(classList **clp,classDef *cd)
{
	classList *new;

	/* Find the end of the list. */

	while (*clp != NULL)
	{
		if ((*clp) -> cd == cd)
			return;

		clp = &(*clp) -> next;
	}

	new = sipMalloc(sizeof (classList));

	new -> cd = cd;
	new -> next = NULL;

	*clp = new;
}


/*
 * Create a new module for the current specification and make it current.
 */

static void newModule(FILE *fp,char *filename)
{
	parseFile(fp,filename,currentModule,FALSE);

	currentModule = sipMalloc(sizeof (moduleDef));

	currentModule -> name = NULL;
	currentModule -> file = filename;
	currentModule -> qualifiers = NULL;
	currentModule -> nrTimeSlots = -1;
	currentModule -> license = NULL;
	currentModule -> next = currentSpec -> moduleList;

	currentSpec -> moduleList = currentModule;
}


/*
 * Switch to parsing a new file.
 */

static void parseFile(FILE *fp,char *name,moduleDef *prevmod,int optional)
{
	parserContext pc;

	pc.ifdepth = skipStackPtr;
	pc.prevmod = prevmod;

	setInputFile(fp,name,&pc,optional);
}


/*
 * Find an interface file, or create a new one.
 */

static ifaceFileDef *findIfaceFile(sipSpec *pt,scopedNameDef *fqname,
				   ifaceFileType iftype,argDef *ad)
{
	ifaceFileDef *iff;

	/* See if the name is already used. */

	for (iff = pt -> ifacefiles; iff != NULL; iff = iff -> next)
	{
		if (!sameScopedName(iff -> fqname,fqname))
			continue;

		/* They must be the same type. */

		if (iff -> type != iftype)
			yyerror("A class, namespace or mapped type has already been defined with the same name");

		/*
		 * If this is a mapped type with the same name defined in a
		 * different module, then check that this type isn't the same
		 * as any of the mapped types defined in that module.
		 */

		if (iftype == mappedtype_iface && iff -> module != currentModule)
		{
			mappedTypeDef *mtd;

			for (mtd = pt -> mappedtypes; mtd != NULL; mtd = mtd -> next)
			{
				if (mtd -> iff != iff)
					continue;

				if (ad -> atype != template_type ||
				    mtd -> type.atype != template_type ||
				    sameBaseType(ad,&mtd -> type,TRUE))
					yyerror("Mapped type has already been defined in another module");
			}

			/*
			 * If we got here then we have a mapped type based on
			 * an existing template, but with unique parameters.
			 * We don't want to use interface files from other
			 * modules, so skip this one.
			 */

			continue;
		}

		return iff;
	}

	iff = sipMalloc(sizeof (ifaceFileDef));

	iff -> name = cacheName(pt,currentModule,scopedNameTail(fqname));
	iff -> type = iftype;
	iff -> fqname = fqname;
	iff -> module = NULL;
	iff -> ifacefileflags = 0;
	iff -> used = NULL;
	iff -> next = pt -> ifacefiles;

	pt -> ifacefiles = iff;

	return iff;
}


/*
 * Find a class definition in a parse tree.
 */

static classDef *findClass(sipSpec *pt,ifaceFileType iftype,
			   scopedNameDef *fqname)
{
	classDef *cd;
	ifaceFileDef *iff;

	/* See if the name is already used. */

	iff = findIfaceFile(pt,fqname,iftype,NULL);

	for (cd = pt -> classes; cd != NULL; cd = cd -> next)
		if (cd -> iff == iff)
			return cd;

	/* Create a new one. */

	cd = sipMalloc(sizeof (classDef));

	cd -> dtorexceptions = NULL;
	cd -> iff = iff;
	cd -> next = pt -> classes;

	pt -> classes = cd;

	return cd;
}


/*
 * Add an interface file to an interface file list if it isn't already there.
 */

void addToUsedList(ifaceFileList **ifflp,ifaceFileDef *iff)
{
	ifaceFileList *iffl;

	while ((iffl = *ifflp) != NULL)
	{
		/* Don't bother if it is already there. */

		if (iffl -> iff == iff)
			return;

		ifflp = &iffl -> next;
	}

	setIsUsed(iff);

	iffl = sipMalloc(sizeof (ifaceFileList));

	iffl -> iff = iff;
	iffl -> next = NULL;

	*ifflp = iffl;
}


/*
 * Find an undefined (or create a new) class definition in a parse tree.
 */

static classDef *newClass(sipSpec *pt,ifaceFileType iftype,scopedNameDef *fqname)
{
	classDef *cd;

	cd = findClass(pt,iftype,fqname);

	/* Check it hasn't already been defined. */

	if (cd -> iff -> module != NULL)
	{
		/*
		 * Namespaces can be defined any number of times in the same
		 * module.
		 */

		if (iftype == namespace_iface && cd -> iff -> module == currentModule)
			return cd;

		yyerror(iftype == class_iface ?
			"The class has already been defined" :
			"The namespace has already been defined in another module");
	}

	cd -> iff -> module = currentModule;

	/* Complete the initialisation. */

	cd -> classflags = 0;
	cd -> classnr = -1;
	cd -> ecd = currentScope();
	cd -> node = NULL;
	cd -> supers = NULL;
	cd -> mro = NULL;
	cd -> ctors = NULL;
	cd -> defctor = NULL;
	cd -> dealloccode = NULL;
	cd -> dtorcode = NULL;
	cd -> members = NULL;
	cd -> overs = NULL;
	cd -> vmembers = NULL;
	cd -> visible = NULL;
	cd -> cppcode = NULL;
	cd -> hdrcode = (cd -> ecd != NULL ? cd -> ecd -> hdrcode : NULL);
	cd -> convtosubcode = NULL;
	cd -> subbase = NULL;
	cd -> convtocode = NULL;

	return cd;
}


/*
 * Tidy up after finishing a class definition.
 */

static void finishClass(classDef *cd,optFlags *optflgs)
{
	overDef *od;

	/* Handle any optional flags. */

	if (findOptFlag(optflgs,"CreatesThread",bool_flag) != NULL)
		setCreatesThread(cd);

	if (cd -> ctors == NULL)
	{
		/* Provide a default ctor. */

		cd -> ctors = sipMalloc(sizeof (ctorDef));
 
		cd -> ctors -> ctorflags = SECT_IS_PUBLIC;
		cd -> ctors -> args.nrArgs = 0;
		cd -> ctors -> cppsig = NULL;
		cd -> ctors -> exceptions = NULL;
		cd -> ctors -> methodcode = NULL;
		cd -> ctors -> membercode = NULL;
		cd -> ctors -> prehook = NULL;
		cd -> ctors -> posthook = NULL;
		cd -> ctors -> next = NULL;

		cd -> defctor = cd -> ctors;

		resetCannotCreate(cd);
	}
	else if (cd -> defctor == NULL)
	{
		ctorDef *ct;

		for (ct = cd -> ctors; ct != NULL; ct = ct -> next)
			if (ct -> args.nrArgs == 0 || ct -> args.args[0].defval != NULL)
			{
				cd -> defctor = ct;
				break;
			}
	}

	/* We can't create this class if it has private abstract functions. */

	for (od = cd -> overs; od != NULL; od = od -> next)
		if (isAbstract(od) && isPrivate(od))
		{
			setCannotCreate(cd);
			break;
		}

	/* We assume a public dtor if nothing specific was provided. */

	if (!isDtor(cd))
		setIsPublicDtor(cd);
}


/*
 * Create a new mapped type.
 */

static mappedTypeDef *newMappedType(sipSpec *pt,argDef *ad)
{
	mappedTypeDef *mtd;
	scopedNameDef *snd;
	ifaceFileDef *iff;

	/* Check that the type is one we want to map. */

	switch (ad -> atype)
	{
	case defined_type:
		snd = ad -> u.snd;
		break;

	case template_type:
		snd = ad -> u.td -> fqname;
		break;

	case struct_type:
		snd = ad -> u.sname;
		break;

	default:
		yyerror("Invalid type for %MappedType");
	}

	iff = findIfaceFile(pt,snd,mappedtype_iface,ad);

	/* Check it hasn't already been defined. */

	for (mtd = pt -> mappedtypes; mtd != NULL; mtd = mtd -> next)
		if (mtd -> iff == iff)
		{
			/*
			 * We allow types based on the same template but with
			 * different arguments.
			 */

			if (ad -> atype != template_type ||
			    sameBaseType(ad,&mtd -> type,TRUE))
				yyerror("Mapped type has already been defined in this module");
		}

	/* The module may not have been set yet. */

	iff -> module = currentModule;

	/* Create a new mapped type. */

	mtd = sipMalloc(sizeof (mappedTypeDef));

	mtd -> type = *ad;
	mtd -> iff = iff;
	mtd -> hdrcode = NULL;
	mtd -> convfromcode = NULL;
	mtd -> convtocode = NULL;
	mtd -> next = pt -> mappedtypes;

	pt -> mappedtypes = mtd;

	return mtd;
}


/*
 * Create a new enum.
 */

static enumDef *newEnum(sipSpec *pt,moduleDef *mod,char *name,int flags)
{
	enumDef *ed;
	classDef *escope = currentScope();

	ed = sipMalloc(sizeof (enumDef));

	ed -> enumflags = flags;
	ed -> fqname = (name != NULL ? text2scopedName(name) : NULL);
	ed -> ecd = escope;
	ed -> module = mod;
	ed -> values = NULL;
	ed -> next = pt -> enums;

	pt -> enums = ed;

	if (escope != NULL)
		setHasEnums(escope);

	return ed;
}


/*
 * Create a new typedef.
 */

static void newTypedef(sipSpec *pt,char *name,argDef *type)
{
	typedefDef *td;
	scopedNameDef *fqname = text2scopedName(name);

	/* Check it doesn't already exist. */

	for (td = pt -> typedefs; td != NULL; td = td -> next)
		if (sameScopedName(td -> fqname,fqname))
		{
			fatalScopedName(fqname);
			fatal(" already defined\n");
		}

	td = sipMalloc(sizeof (typedefDef));

	td -> fqname = fqname;
	td -> ecd = currentScope();
	td -> type = *type;
	td -> next = pt -> typedefs;

	pt -> typedefs = td;
}


/*
 * Create a new variable.
 */

static void newVar(sipSpec *pt,moduleDef *mod,char *name,int isstatic,
		   argDef *type,codeBlock *code)
{
	varDef *var;
	classDef *escope = currentScope();
	nameDef *nd = cacheName(pt,mod,name);

	checkAttributes(pt,escope,nd,var_attr);

	var = sipMalloc(sizeof (varDef));

	var -> name = nd;
	var -> fqname = text2scopedName(name);
	var -> ecd = escope;
	var -> module = mod;
	var -> varflags = 0;
	var -> type = *type;
	var -> accessfunc = code;
	var -> next = pt -> vars;

	if (isstatic)
		setIsStaticVar(var);

	pt -> vars = var;
}


/*
 * Create a new ctor.
 */

static void newCtor(char *name,int sectFlags,funcArgs *args,optFlags *optflgs,
		    codeBlock *methodcode,codeBlock *membercode,
		    throwArgs *exceptions,signatureDef *cppsig)
{
	ctorDef *ct, **ctp;
	classDef *cd = currentScope();

	if (methodcode != NULL && membercode != NULL)
		yyerror("Cannot provide %MethodCode and %MemberCode");

	/* Check the name of the constructor. */

	if (strcmp(classBaseName(cd),name) != 0)
		yyerror("Constructor doesn't have the same name as its class");

	/*
	 * Find the end of the list and, at the same time, check for any
	 * existing one with the same signature.
	 */

	for (ctp = &cd -> ctors; *ctp != NULL; ctp = &(*ctp) -> next)
		if (sameFuncArgs(&(*ctp) -> args,args,FALSE))
			yyerror("A constructor with the same Python signature has already been defined");

	/* Add to the list of constructors. */

	ct = sipMalloc(sizeof (ctorDef));

	ct -> ctorflags = sectFlags;
	ct -> args = *args;
	ct -> cppsig = cppsig;
	ct -> exceptions = exceptions;
	ct -> methodcode = methodcode;
	ct -> membercode = membercode;
	ct -> next = NULL;

	if (isProtectedCtor(ct))
		setIsComplex(cd);

	if (!isPrivateCtor(ct))
		resetCannotCreate(cd);

	getHooks(optflgs,&ct -> prehook,&ct -> posthook);

	if (findOptFlag(optflgs,"Default",bool_flag) != NULL)
	{
		if (cd -> defctor != NULL)
			yyerror("A constructor with the /Default/ flag has already been defined");

		cd -> defctor = ct;
	}

	*ctp = ct;
}


/*
 * Create a new function.
 */

static void newFunction(sipSpec *pt,moduleDef *mod,int sflags,int isstatic,
			int isvirt,argDef *type,char *name,funcArgs *args,
			int isconst,int isabstract,optFlags *optflgs,
			codeBlock *methodcode,codeBlock *membercode,
			codeBlock *vcode,codeBlock *ovcode,
			throwArgs *exceptions,signatureDef *cppsig)
{
	static struct slot_map {
		char *name;		/* The slot name. */
		slotType type;		/* The corresponding type. */
		int hwcode;		/* If handwritten code is required. */
		int nrargs;		/* Nr. of arguments. */
	} slot_table[] = {
		{"__str__", str_slot, TRUE, 0},
		{"__unicode__", unicode_slot, TRUE, 0},
		{"__int__", int_slot, FALSE, 0},
		{"__len__", len_slot, TRUE, 0},
		{"__contains__", contains_slot, TRUE, 1},
		{"__add__", add_slot, FALSE, 1},
		{"__sub__", sub_slot, FALSE, 1},
		{"__mul__", mul_slot, FALSE, 1},
		{"__div__", div_slot, FALSE, 1},
		{"__mod__", mod_slot, FALSE, 1},
		{"__and__", and_slot, FALSE, 1},
		{"__or__", or_slot, FALSE, 1},
		{"__xor__", xor_slot, FALSE, 1},
		{"__lshift__", lshift_slot, FALSE, 1},
		{"__rshift__", rshift_slot, FALSE, 1},
		{"__iadd__", iadd_slot, FALSE, 1},
		{"__isub__", isub_slot, FALSE, 1},
		{"__imul__", imul_slot, FALSE, 1},
		{"__idiv__", idiv_slot, FALSE, 1},
		{"__imod__", imod_slot, FALSE, 1},
		{"__iand__", iand_slot, FALSE, 1},
		{"__ior__", ior_slot, FALSE, 1},
		{"__ixor__", ixor_slot, FALSE, 1},
		{"__ilshift__", ilshift_slot, FALSE, 1},
		{"__irshift__", irshift_slot, FALSE, 1},
		{"__invert__", invert_slot, FALSE, 0},
		{"__call__", call_slot, TRUE, -1},
		{"__getitem__", getitem_slot, TRUE, -1},
		{"__setitem__", setitem_slot, TRUE, -1},
		{"__delitem__", delitem_slot, TRUE, -1},
		{"__lt__", lt_slot, FALSE, 1},
		{"__le__", le_slot, FALSE, 1},
		{"__eq__", eq_slot, FALSE, 1},
		{"__ne__", ne_slot, FALSE, 1},
		{"__gt__", gt_slot, FALSE, 1},
		{"__ge__", ge_slot, FALSE, 1},
		{"__cmp__", cmp_slot, FALSE, 1},
		{"__nonzero__", nonzero_slot, TRUE, 0},
		{"__neg__", neg_slot, FALSE, 0},
		{"__repr__", repr_slot, TRUE, 0},
		{NULL}
	};

	classDef *cd = currentScope();
	char *pname;
	int factory, xferback;
	overDef *od, **odp, **headp;
	optFlag *of;
	struct slot_map *sm;
	slotType st;

	if (methodcode != NULL && membercode != NULL)
		yyerror("Cannot provide %MethodCode and %MemberCode");

	if (vcode != NULL && ovcode != NULL)
		yyerror("Cannot provide %VirtualCatcherCode and %VirtualCode");

        /* Get the slot type. */

	st = no_slot;

	for (sm = slot_table; sm -> name != NULL; ++sm)
		if (strcmp(sm -> name,name) == 0)
		{
			/* Apply the restrictions on operators. */

			if (cd == NULL || (sflags & SECT_IS_PUBLIC) == 0)
				yyerror("Operators must be defined in the public section of a class");

			if (sm -> hwcode && methodcode == NULL && membercode == NULL)
				yyerror("This operator requires %MethodCode or %MemberCode");

			if (sm -> nrargs < 0)
			{
				int exact_nr;

				/*
				 * These require an exact number, for SIP v3.x
				 * but not for SIP v4.x.
				 */
				switch (sm -> type)
				{
				case getitem_slot:
				case delitem_slot:
					exact_nr = 1;
					break;

				case setitem_slot:
					exact_nr = 2;
					break;

				default:
					exact_nr = 0;
				}

				if (exact_nr > 0)
					if (args -> nrArgs < exact_nr)
						yyerror("Incorrect number of arguments to operator");
					else if (args -> nrArgs > exact_nr)
						yyerror("Too many arguments to operator - use SIP v4.0 or later");
			}
			else if (sm -> nrargs != args -> nrArgs)
				yyerror("Incorrect number of arguments to operator");

			if (isvirt)
				yyerror("Operators cannot be virtual");

			if (isabstract)
				yyerror("Operators cannot be abstract");

			st = sm -> type;

			break;
		}

	headp = (cd != NULL ?  &cd -> overs : &pt -> overs);

	/* See if it is a factory method. */
	if (findOptFlag(optflgs,"Factory",bool_flag) != NULL)
		factory = TRUE;
	else
	{
		int a;

		factory = FALSE;

		/* Check /TransferThis/ wasn't specified. */
		for (a = 0; a < args -> nrArgs; ++a)
			if (isThisTransferred(&args -> args[a]))
				yyerror("/TransferThis/ may only be specified in constructors and /Factory/ methods");
	}

	/* See if the result is to be returned to Python ownership. */
	xferback = (findOptFlag(optflgs,"TransferBack",bool_flag) != NULL);

	if (factory && xferback)
		yyerror("/TransferBack/ and /Factory/ cannot both be specified");

	/* Use the C++ name if a Python name wasn't given. */

	if ((of = findOptFlag(optflgs,"PyName",name_flag)) != NULL)
		pname = of -> fvalue.sval;
	else
		pname = name;

	/* Create a new overload definition. */

	od = sipMalloc(sizeof (overDef));

	/* Set the overload flags. */

	od -> overflags = sflags;

	if (factory)
		setIsFactory(od);

	if (xferback)
		setIsResultTransferredBack(od);

	if (isProtected(od))
		setIsComplex(cd);

	if ((isSlot(od) || isSignal(od)) && !isPrivate(od))
	{
		if (isSignal(od))
			setIsComplex(cd);

		pt -> sigslots = TRUE;
	}

	if (isSignal(od) && (methodcode != NULL || membercode != NULL || vcode != NULL))
		yyerror("Cannot provide code for signals");

	if (isstatic)
	{
		if (isSlot(od) || isSignal(od))
			yyerror("Static functions cannot be slots or signals");

		if (isvirt)
			yyerror("Static functions cannot be virtual");

		setIsStatic(od);
	}

	if (isconst)
		setIsConst(od);

	if (isabstract)
	{
		if (sflags == 0)
			yyerror("Non-class function specified as abstract");

		setIsAbstract(od);
	}

	if ((of = findOptFlag(optflgs,"AutoGen",opt_name_flag)) != NULL)
	{
		setIsAutoGen(od);

		if (of -> fvalue.sval != NULL)
		{
			qualDef *qd;

			if ((qd = findQualifier(pt,of -> fvalue.sval)) == NULL || qd -> qtype != feature_qualifier)
				yyerror("No such feature");

			if (isExcluded(qd))
				resetIsAutoGen(od);
		}
	}

	if (isvirt)
	{
		if (isSignal(od))
			yyerror("Virtual signals aren't supported");

		setIsVirtual(od);
		setIsComplex(cd);
	}
	else if (vcode != NULL)
		yyerror("%VirtualCode provided for non-virtual function");

	od -> cppname = name;
	od -> args = *args;
	od -> cppsig = cppsig;
	od -> exceptions = exceptions;
	od -> methodcode = methodcode;
	od -> membercode = membercode;
	od -> virtcode = vcode;
	od -> ovirtcode = ovcode;
	od -> common = findFunction(pt,mod,cd,pname,st);

	/* For Python slots, %MethodCode and %MemberCode are synonymous. */

	if (od -> common -> slot != no_slot && membercode != NULL)
	{
		od -> methodcode = membercode;
		od -> membercode = NULL;
	}

	/* Methods that run in new threads must be virtual. */

	if (findOptFlag(optflgs,"NewThread",bool_flag) != NULL)
	{
		if (!isvirt)
			yyerror("/NewThread/ may only be specified for virtual methods");

		setIsNewThread(od);
	}

	getHooks(optflgs,&od -> prehook,&od -> posthook);

	if (type -> atype == voidptr_type && type -> nrderefs == 0)
		od -> result = NULL;
	else
	{
		od -> result = sipMalloc(sizeof (argDef));
		*od -> result = *type;
	}

	od -> next = NULL;

	/*
	 * Find the end of the list and, at the same time, check for any
	 * existing one with the same signature.
	 */

	for (odp = headp; *odp != NULL; odp = &(*odp) -> next)
	{
		if ((*odp) -> common != od -> common)
			continue;

		if (!sameOverload(*odp,od,FALSE))
			continue;

		yyerror("A function with the same Python signature has already been defined");
	}

	*odp = od;
}


/*
 * Cache a name in a module.
 */

static nameDef *cacheName(sipSpec *pt,moduleDef *mod,char *name)
{
	nameDef *nd;

	/* See if it already exists. */

	for (nd = pt -> namecache; nd != NULL; nd = nd -> next)
		if (strcmp(nd -> text,name) == 0)
			return nd;

	/* Create a new one. */

	nd = sipMalloc(sizeof (nameDef));

	nd -> text = name;
	nd -> module = mod;
	nd -> next = pt -> namecache;

	pt -> namecache = nd;

	return nd;
}


/*
 * Find (or create) an overloaded function name.
 */

static memberDef *findFunction(sipSpec *pt,moduleDef *mod,classDef *cd,
			       char *pname,slotType st)
{
	memberDef *md, **flist;
	nameDef *pnd;

	/* Cache the name. */

	pnd = cacheName(pt,mod,pname);

	/* Check there is no name clash. */

	checkAttributes(pt,cd,pnd,func_attr);

	/* See if it already exists. */

	flist = (cd != NULL ? &cd -> members : &pt -> othfuncs);

	for (md = *flist; md != NULL; md = md -> next)
		if (md -> pyname == pnd)
			return md;

	/* Create a new one. */

	md = sipMalloc(sizeof (memberDef));

	md -> pyname = pnd;
	md -> slot = st;
	md -> module = mod;
	md -> next = *flist;

	*flist = md;

	return md;
}


/*
 * Search a set of flags for a particular one and check its type.
 */

static optFlag *findOptFlag(optFlags *flgs,char *name,flagType ft)
{
	int f;

	for (f = 0; f < flgs -> nrFlags; ++f)
	{
		optFlag *of = &flgs -> flags[f];

		if (strcmp(of -> fname,name) == 0)
		{
			/*
			 * An optional name can look like a boolean or a name.
			 */

			if (ft == opt_name_flag)
			{
				if (of -> ftype == bool_flag)
				{
					of -> ftype = opt_name_flag;
					of -> fvalue.sval = NULL;
				}
				else if (of -> ftype == name_flag)
					of -> ftype = opt_name_flag;
			}

			if (ft != of -> ftype)
				yyerror("Optional flag has a value of the wrong type");

			return of;
		}
	}

	return NULL;
}


/*
 * A name is going to be used as a Python attribute name within a Python scope
 * (ie. a Python dictionary), so check against what we already know is going in
 * the same scope in case there is a clash.
 */

static void checkAttributes(sipSpec *pt,classDef *pyscope,nameDef *attr,
			    attrType at)
{
	enumDef *ed;
	varDef *vd;
	classDef *cd;

	/* Check the enum values. */

	for (ed = pt -> enums; ed != NULL; ed = ed -> next)
	{
		enumValueDef *evd;

		if (ed -> ecd != pyscope)
			continue;

		for (evd = ed -> values; evd != NULL; evd = evd -> next)
			if (evd -> name == attr)
				yyerror("There is already an enum value in scope with the same Python name");
	}

	/* Check the variables. */

	for (vd = pt -> vars; vd != NULL; vd = vd -> next)
	{
		if (vd -> ecd != pyscope)
			continue;

		if (vd -> name != attr)
			continue;

		yyerror("There is already a variable in scope with the same Python name");
	}

	/*
	 * Only check the members if this attribute isn't a member because we
	 * can handle members with the same name in the same scope.
	 */

	if (at != func_attr)
	{
		memberDef *md, *membs;

		membs = (pyscope != NULL ? pyscope -> members : pt -> othfuncs);

		for (md = membs; md != NULL; md = md -> next)
		{
			overDef *od, *overs;

			if (md -> pyname != attr)
				continue;

			/* Check for a conflict with all overloads. */

			overs = (pyscope != NULL ? pyscope -> overs : pt -> overs);

			for (od = overs; od != NULL; od = od -> next)
			{
				if (od -> common != md)
					continue;

				yyerror("There is already a function in scope with the same Python name");
			}
		}
	}

	/* Check the classes. */

	for (cd = pt -> classes; cd != NULL; cd = cd -> next)
	{
		if (cd -> ecd != pyscope)
			continue;

		if (cd -> iff -> name != attr)
			continue;

		yyerror("There is already a class or namespace in scope with the same Python name");
	}
}


/*
 * Append a code block to a list of them.  Append is needed to give the
 * specifier easy control over the order of the documentation.
 */

static void appendCodeBlock(codeBlock **headp,codeBlock *new)
{
	while (*headp != NULL)
		headp = &(*headp) -> next;

	*headp = new;
}


/*
 * Handle the end of a fully parsed a file.
 */

static void handleEOF()
{
	/*
	 * Check that the number of nested if's is the same as when we started
	 * the file.
	 */

	if (skipStackPtr > newContext.ifdepth)
		fatal("Too many %%If statements in %s\n",previousFile);

	if (skipStackPtr < newContext.ifdepth)
		fatal("Too many %%End statements in %s\n",previousFile);
}


/*
 * Handle the end of a fully parsed a module.
 */

static void handleEOM()
{
	/* Check it has been named. */

	if (currentModule -> name == NULL)
		fatal("No %%Module has been specified for module defined in %s\n",previousFile);

	/* The previous module is now current. */

	currentModule = newContext.prevmod;
}


/*
 * Find an existing qualifier.
 */

static qualDef *findQualifier(sipSpec *pt,char *name)
{
	moduleDef *mod;

	for (mod = pt -> moduleList; mod != NULL; mod = mod -> next)
	{
		qualDef *qd;

		for (qd = mod -> qualifiers; qd != NULL; qd = qd -> next)
			if (strcmp(qd -> name,name) == 0)
				return qd;
	}

	return NULL;
}


/*
 * Return a copy of a scoped name.
 */

scopedNameDef *copyScopedName(scopedNameDef *snd)
{
	scopedNameDef *head;

	head = NULL;

	while (snd != NULL)
	{
		appendScopedName(&head,text2scopePart(snd -> name));
		snd = snd -> next;
	}

	return head;
}


/*
 * Append a name to a list of scopes.
 */

void appendScopedName(scopedNameDef **headp,scopedNameDef *newsnd)
{
	while (*headp != NULL)
		headp = &(*headp) -> next;

	*headp = newsnd;
}


/*
 * Free a scoped name - but not the text itself.
 */

void freeScopedName(scopedNameDef *snd)
{
	while (snd != NULL)
	{
		scopedNameDef *next = snd -> next;

		free(snd);

		snd = next;
	}
}


/*
 * Convert a text string to a scope part structure.
 */

scopedNameDef *text2scopePart(char *text)
{
	scopedNameDef *snd;

	snd = sipMalloc(sizeof (scopedNameDef));

	snd -> name = text;
	snd -> next = NULL;

	return snd;
}


/*
 * Convert a text string to a fully scoped name.
 */

static scopedNameDef *text2scopedName(char *text)
{
	classDef *cd = currentScope();
	scopedNameDef *snd;

	snd = (cd != NULL ? copyScopedName(cd -> iff -> fqname) : NULL);

	appendScopedName(&snd,text2scopePart(text));

	return snd;
}


/*
 * Return a pointer to the tail part of a scoped name.
 */

char *scopedNameTail(scopedNameDef *snd)
{
	if (snd == NULL)
		return NULL;

	while (snd -> next != NULL)
		snd = snd -> next;

	return snd -> name;
}


/*
 * Push the given scope onto the scope stack.
 */

static void pushScope(classDef *scope)
{
	if (currentScopeIdx >= MAX_NESTED_SCOPE)
		fatal("Internal error: increase the value of MAX_NESTED_SCOPE\n");

	scopeStack[currentScopeIdx] = scope;
	sectFlagsStack[currentScopeIdx] = sectionFlags;

	++currentScopeIdx;
}


/*
 * Pop the scope stack.
 */

static void popScope(void)
{
	if (currentScopeIdx > 0)
		sectionFlags = sectFlagsStack[currentScopeIdx--];
}


/*
 * Return non-zero if the current input should be parsed rather than be
 * skipped.
 */

static int notSkipping()
{
	return (skipStackPtr == 0 ? TRUE : skipStack[skipStackPtr - 1]);
}


/*
 * Return the value of an expression involving a time period.
 */

static int timePeriod(sipSpec *pt,char *lname,char *uname)
{
	int this;
	qualDef *qd, *lower, *upper;
	moduleDef *mod;

	if (lname == NULL)
		lower = NULL;
	else if ((lower = findQualifier(pt,lname)) == NULL || lower -> qtype != time_qualifier)
		yyerror("Lower bound is not a time version");

	if (uname == NULL)
		upper = NULL;
	else if ((upper = findQualifier(pt,uname)) == NULL || upper -> qtype != time_qualifier)
		yyerror("Upper bound is not a time version");

	/* Sanity checks on the bounds. */

	if (lower == NULL && upper == NULL)
		yyerror("Lower and upper bounds cannot both be omitted");

	if (lower != NULL && upper != NULL)
	{
		if (lower -> module != upper -> module)
			yyerror("Lower and upper bounds are from different timelines");

		if (lower == upper)
			yyerror("Lower and upper bounds must be different");

		if (lower -> order > upper -> order)
			yyerror("Later version specified as lower bound");
	}

	/* Go through each slot in the relevant timeline. */

	if (lower != NULL)
		mod = lower -> module;
	else
		mod = upper -> module;

	this = FALSE;

	for (qd = mod -> qualifiers; qd != NULL; qd = qd -> next)
	{
		if (qd -> qtype != time_qualifier)
			continue;

		if (lower != NULL && qd -> order < lower -> order)
			continue;

		if (upper != NULL && qd -> order >= upper -> order)
			continue;

		/*
		 * This is within the required range so if it is also needed
		 * then the expression is true.
		 */

		if (isNeeded(qd))
		{
			this = TRUE;
			break;
		}
	}

	return this;
}


/*
 * Return the value of an expression involving a single platform or feature.
 */

static int platOrFeature(sipSpec *pt,char *name,int optnot)
{
	int this;
	qualDef *qd;

	if ((qd = findQualifier(pt,name)) == NULL || qd -> qtype == time_qualifier)
		yyerror("No such platform or feature");

	/* Assume this sub-expression is false. */

	this = FALSE;

	if (qd -> qtype == feature_qualifier)
	{
		if (!isExcluded(qd))
			this = TRUE;
	}
	else if (isNeeded(qd))
		this = TRUE;

	if (optnot)
		this = !this;

	return this;
}


/*
 * Return TRUE if the given qualifier is excluded.
 */

static int isExcluded(qualDef *qd)
{
	stringList *sl;

	for (sl = excludedQualifiers; sl != NULL; sl = sl -> next)
		if (strcmp(qd -> name,sl -> s) == 0)
			return TRUE;

	return FALSE;
}


/*
 * Return TRUE if the given qualifier is needed.
 */

static int isNeeded(qualDef *qd)
{
	stringList *sl;

	for (sl = neededQualifiers; sl != NULL; sl = sl -> next)
		if (strcmp(qd -> name,sl -> s) == 0)
			return TRUE;

	return FALSE;
}


/*
 * Return the current scope.  currentScope() is only valid if notSkipping()
 * returns non-zero.
 */

static classDef *currentScope(void)
{
	return (currentScopeIdx > 0 ? scopeStack[currentScopeIdx - 1] : NULL);
}


/*
 * Create a new qualifier.
 */

static void newQualifier(sipSpec *pt,moduleDef *mod,int order,char *name,
			 qualType qt)
{
	qualDef *qd;

	/* Check it doesn't already exist. */

	if (findQualifier(pt,name) != NULL)
		yyerror("Version is already defined");

	qd = sipMalloc(sizeof (qualDef));

	qd -> name = name;
	qd -> qtype = qt;
	qd -> module = mod;
	qd -> order = order;
	qd -> next = mod -> qualifiers;

	mod -> qualifiers = qd;
}


/*
 * Create a new imported module.
 */

static void newImport(sipSpec *pt,char *name)
{
	/* Ignore if the file has already been imported. */

	moduleDef *mod;

	for (mod = pt -> moduleList; mod != NULL; mod = mod -> next)
		if (strcmp(mod -> file,name) == 0)
			return;

	newModule(NULL,name);
}


/*
 * If the use of an interface is by the main module, add it to the used list.
 */

static void usedInMainModule(sipSpec *pt,ifaceFileDef *iff)
{
	if (isMainModule(iff -> module))
		addToUsedList(&pt -> used,iff);
}


/*
 * Set up pointers to hook names.
 */

static void getHooks(optFlags *optflgs,char **pre,char **post)
{
	optFlag *of;

	if ((of = findOptFlag(optflgs,"PreHook",name_flag)) != NULL)
		*pre = of -> fvalue.sval;
	else
		*pre = NULL;

	if ((of = findOptFlag(optflgs,"PostHook",name_flag)) != NULL)
		*post = of -> fvalue.sval;
	else
		*post = NULL;
}
